# FileIO

[![Build status](https://github.com/JuliaIO/FileIO.jl/actions/workflows/test.yml/badge.svg)](https://github.com/JuliaIO/FileIO.jl/actions/workflows/test.yml)
[![codecov](https://codecov.io/gh/JuliaIO/FileIO.jl/branch/master/graph/badge.svg?token=I0NjrZpJKh)](https://codecov.io/gh/JuliaIO/FileIO.jl)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaIO.github.io/FileIO.jl/stable)

# FileIO.jl

FileIO aims to provide a common framework for detecting file formats
and dispatching to appropriate readers/writers.  The two core
functions in this package are called `load` and `save`, and offer
high-level support for formatted files (in contrast with julia's
low-level `read` and `write`).  To avoid name conflicts, packages that
provide support for standard file formats through functions named
`load` and `save` are encouraged to register with FileIO.

## Help

You can get an API overview by typing `?FileIO` at the REPL prompt.
Individual functions have their own help too, e.g., `?add_format`.

For more detailed help, including information about how you can add support
for additional file formats, see the [documentation](https://JuliaIO.github.io/FileIO.jl/stable).

using FileIO
using Test

# Stub readers---these might bork any existing readers, so don't
# run these tests while doing other things!
module TestLoadSave
    import FileIO: File, @format_str
    load(file::File{format"PBMText"})   = "PBMText"
    load(file::File{format"PBMBinary"}) = "PBMBinary"
    load(file::File{format"JLD"})       = "JLD"
    load(file::File{format"GZIP"})      = "GZIP"
end
module TestLoadSave2
    import FileIO: File, @format_str
    fileio_load(file::File{format"HDF5"})      = "HDF5"
    fileio_load(file::File{format"BIB"})       = "BIB"
    fileio_load(file::File{format"DCM"})       = "DCM"
end

@testset "FakeIO" begin
    sym2loader = copy(FileIO.sym2loader)
    sym2saver = copy(FileIO.sym2saver)

    try
        empty!(FileIO.sym2loader)
        empty!(FileIO.sym2saver)
        file_dir = joinpath(dirname(@__FILE__), "files")
        file_path = Path(file_dir)

        @testset "Load $(typeof(fp))" for fp in (file_dir, file_path)

            add_loader(format"PBMText", TestLoadSave)
            add_loader(format"PBMBinary", TestLoadSave)
            add_loader(format"HDF5", TestLoadSave2)
            add_loader(format"JLD", TestLoadSave)
            add_loader(format"GZIP", TestLoadSave)
            add_loader(format"BIB", TestLoadSave2)
            add_loader(format"DCM", TestLoadSave2)

            @test load(joinpath(fp,"file1.pbm")) == "PBMText"
            @test load(joinpath(fp,"file2.pbm")) == "PBMBinary"

            # Regular HDF5 file with magic bytes starting at position 0
            @test load(joinpath(fp,"file1.h5")) == "HDF5"
            # This one is actually a JLD file saved with an .h5 extension,
            # and the JLD magic bytes edited to prevent it from being recognized
            # as JLD.
            # JLD files are also HDF5 files, so this should be recognized as
            # HDF5. However, what makes this more interesting is that the
            # magic bytes start at position 512.
            @test load(joinpath(fp,"file2.h5")) == "HDF5"
            # JLD file saved with .jld extension
            @test load(joinpath(fp,"file.jld")) == "JLD"
            # GZIP file saved with .gz extension
            @test load(joinpath(fp,"file.csv.gz")) == "GZIP"
            # Bibliography file saved with .bib extension
            @test load(joinpath(fp,"file.bib")) == "BIB"
            # DICOM file saved with .dcm extension
            @test load(joinpath(fp,"CT_JPEG70.dcm")) == "DCM"
            @test_throws Exception load("missing.fmt")
        end
    finally
        empty!(FileIO.sym2loader)
        empty!(FileIO.sym2saver)
        merge!(FileIO.sym2loader, sym2loader)
        merge!(FileIO.sym2saver, sym2saver)
    end
end

# A tiny but complete example
# DUMMY format is:
#  - n, a single Int64
#  - a vector of length n of UInt8s

add_format(format"DUMMY", b"DUMMY", ".dmy")

module Dummy

    using FileIO

    mutable struct DummyReader{IOtype}
        stream::IOtype
        ownstream::Bool
        bytesleft::Int64
    end

    function DummyReader(stream, ownstream)
        read(stream, 5) == magic(format"DUMMY") || error("wrong magic bytes")
        DummyReader(stream, ownstream, read(stream, Int64))
    end

    function Base.read(stream::DummyReader, n=stream.bytesleft)
        toread = min(n, stream.bytesleft)
        buf = read(stream.stream, toread)
        stream.bytesleft -= length(buf)
        buf
    end

    Base.eof(stream::DummyReader) = stream.bytesleft == 0 || eof(stream.stream)
    Base.close(stream::DummyReader) = stream.ownstream && close(stream.stream)

    mutable struct DummyWriter{IOtype}
        stream::IOtype
        ownstream::Bool
        headerpos::Int64
        byteswritten::Int
    end

    function DummyWriter(stream, ownstream)
        write(stream, magic(format"DUMMY"))  # Write the magic bytes
        # store the position where we'll need to write the length
        pos = position(stream)
        # write a dummy length value
        write(stream, 0xffffffffffffffff)
        DummyWriter(stream, ownstream, pos, 0)
    end

    function Base.write(stream::DummyWriter, data)
        udata = convert(Vector{UInt8}, data)
        n = write(stream.stream, udata)
        stream.byteswritten += n

        n
    end

    function Base.close(stream::DummyWriter)
        here = position(stream.stream)
        # go back and write the header
        seek(stream.stream, stream.headerpos)
        write(stream.stream, convert(Int64, stream.byteswritten))
        seek(stream.stream, here)
        stream.ownstream && close(stream.stream)

        nothing
    end

    loadstreaming(s::Stream{format"DUMMY"}) = DummyReader(s, false)
    loadstreaming(file::File{format"DUMMY"}) = DummyReader(open(file), true)
    savestreaming(s::Stream{format"DUMMY"}) = DummyWriter(s, false)
    savestreaming(file::File{format"DUMMY"}) = DummyWriter(open(file, "w"), true)

    # we could implement `load` and `save` in terms of their streaming versions
    function load(file::File{format"DUMMY"}; extra=UInt8[])
        open(file) do s
            load(s; extra=extra)
        end
    end

    function metadata(file::File{format"DUMMY"})
        s = open(file)
        skipmagic(s)
        n = read(s, Int64)
        close(s)
        return n
    end

    function load(s::Stream{format"DUMMY"}; extra=UInt8[])
        skipmagic(s)
        n = read(s, Int64)
        out = Vector{UInt8}(undef, n)
        read!(s, out)
        # verify that the extradata is as expected. This is just to test that
        # the keyword arguments are handled properly in loading and saving
        extradata = read(s, length(extra))
        if extradata != extra
            throw(ErrorException("Got extra data $extradata instead of $extra"))
        end
        close(s)
        out
    end

    function save(file::File{format"DUMMY"}, data; extra=UInt8[])
        open(file, "w") do s
            save(s, data; extra=extra)
        end
    end

    function save(s::Stream{format"DUMMY"}, data; extra=UInt8[])
        write(s, magic(format"DUMMY"))  # Write the magic bytes
        write(s, convert(Int64, length(data)))
        udata = convert(Vector{UInt8}, data)
        write(s, udata)
        write(s, extra)
    end

    add_loader(format"DUMMY", Dummy)
    add_saver(format"DUMMY", Dummy)

end # module Dummy

@testset "Save" begin
    a = [0x01,0x02,0x03]
    fn = string(tempname(), ".dmy")
    save(fn, a)
    @test metadata(fn) == 3

    # Test for absolute paths
    cd(dirname(fn)) do
        fnrel = basename(fn)
        f = query(fnrel)
        @test isabspath(filename(f))
        @test endswith(filename(f),fn) # TravisOSX prepends "/private"
        f = File{format"DUMMY"}(fnrel)
        @test !(isabspath(filename(f)))
        open(f) do s
            @test isabspath(filename(s))
            @test endswith(filename(s), fn)
        end
    end

    fn2 = string(tempname(), ".dmy")
    a |> save(fn2)

    # Test for absolute paths
    cd(dirname(fn2)) do
        fnrel = basename(fn2)
        f = query(fnrel)
        @test isabspath(filename(f))
        @test endswith(filename(f),fn2) # TravisOSX prepends "/private"
        f = File{format"DUMMY"}(fnrel)
        @test !(isabspath(filename(f)))
        open(f) do s
            @test isabspath(filename(s))
            @test endswith(filename(s),fn2)
        end
    end
    rm(fn2)

    # Test IO
    b = load(query(fn))
    @test a == b

    b = open(query(fn)) do s
        load(s)
    end
    @test a == b

    # low-level I/O test
    open(query(fn)) do s
        @test position(s) == 0
        skipmagic(s)
        @test position(s) == length(magic(format"DUMMY"))
        seek(s, 1)
        @test position(s) == 1
        seekstart(s)
        @test position(s) == 0
        seekend(s)
        @test eof(s)
        skip(s, -position(s)+1)
        @test position(s) == 1
        @test isreadonly(s)
        @test isopen(s)
        @test read(s,2) == b"UM"
    end
    rm(fn)

    # streaming I/O with filenames
    fn = string(tempname(), ".dmy")
    save(fn, a)
    loadstreaming(fn) do reader
        @test read(reader) == a
    end
    rm(fn)
    savestreaming(fn) do writer
        write(writer, a)
    end
    @test load(fn) == a
    rm(fn)

    if Threads.nthreads() > 1
        Threads.@threads for i in 1:(Threads.nthreads() * 5)
            fn = string(tempname(), ".dmy")
            save(fn, a)
        end
    end

    # force format
    fn = string(tempname(), ".dmy")
    savestreaming(format"DUMMY", fn) do writer
        write(writer, a)
    end
    @test load(fn) == a
    rm(fn)

    # streaming I/O with streams
    save(fn, a)
    open(fn) do io
        loadstreaming(io) do reader
            @test read(reader) == a
        end
        @test isopen(io)
    end
    rm(fn)
    open(fn, "w") do io
        savestreaming(format"DUMMY", io) do writer
            write(writer, a)
        end
        @test isopen(io)
    end
    @test load(fn) == a
    rm(fn)

    # test keyword arguments

    a = [0x01,0x02,0x03]
    fn = string(tempname(), ".dmy")
    save(fn, a; extra=[0x42, 0x43])
    # the loader verifies that the extra data was written properly
    load(fn; extra=[0x42, 0x43])

    @test_throws Exception save("missing.fmt",5)
end

@testset "Overwrite file with bad magic bytes" begin
    # issue #267
    a = [0x01,0x02,0x03]
    fn = tempname()*".dmy"
    open(fn, "w") do io
        write(io, "Ceci n'est pas un DUMMY")
    end
    save(fn, a)
    @test isa(query(fn), File{format"DUMMY"})
    @test load(fn) == a
    rm(fn)
end

del_format(format"DUMMY")

# PPM/PBM can be either binary or text. Test that the defaults work,
# and that we can force a choice.
module AmbigExt
    using FileIO: File, @format_str, Stream, stream, skipmagic

    load(f::File{format"AmbigExt1"}) = open(f) do io
        skipmagic(io)
        read(stream(io), String)
    end
    load(f::File{format"AmbigExt2"}) = open(f) do io
        skipmagic(io)
        read(stream(io), String)
    end

    fileio_save(f::File{format"AmbigExt1"}, testdata) = open(f, "w") do io
        s = stream(io)
        print(s, "ambigext1")
        print(s, testdata)
    end
    fileio_save(f::File{format"AmbigExt2"}, testdata) = open(f, "w") do io
        s = stream(io)
        print(s, "ambigext2")
        print(s, testdata)
    end
end

@testset "Ambiguous extension" begin
    add_format(format"AmbigExt1", "ambigext1", ".aext", [AmbigExt])
    add_format(format"AmbigExt2", "ambigext2", ".aext", [AmbigExt])
    A = "this is a test"
    fn = string(tempname(), ".aext")
    # Test the forced version first: we wouldn't want some method in Netpbm
    # coming to the rescue here, we want to rely on FileIO's logic.
    # `save(fn, A)` will load Netpbm, which could conceivably mask a failure
    # in the next line.
    save(format"AmbigExt2", fn, A)

    B = load(fn)
    @test B == A
    @test typeof(query(fn)) <: File{format"AmbigExt2"}
    rm(fn)

    save(fn, A)
    B = load(fn)
    @test B == A
    @test typeof(query(fn)) <: File{format"AmbigExt1"}

    rm(fn)
    del_format(format"AmbigExt1")
    del_format(format"AmbigExt2")
end

@testset "Absent file" begin
    @test_throws Union{ArgumentError,SystemError} load("nonexistent.oops")
end

module BadOverride
    using FileIO
    FileIO.load(::File{format"OVERRIDE"}) = 22
    add_format(format"OVERRIDE", "OVRD0101", ".ovr", [BadOverride])
end

@testset "Warn FileIO overrides" begin
    fn = string(tempname(), ".ovr")
    open(fn, "w") do io
        write(io, magic(:OVERRIDE))
        print(io, "\nDone")
    end
    @test (@test_logs (:warn, r"incorrectly extends FileIO functions \(see FileIO documentation\)") load(fn)) == 22
end

# Julia 1.0 in Windows (Github Action) is problematic when downloading the file so we skip it
if VERSION >= v"1.3" begin
    @testset "CSV load from URL via CSVFiles (#320)" begin
        f = joinpath("files", "data.csv")
        c1 = load(f)
        c2 = load("https://raw.githubusercontent.com/queryverse/CSVFiles.jl/v0.2.0/test/data.csv")
        @test collect(c1) == collect(c2)
    end
end

end

# This file contains code that helps to query from the registry to determine the format

"""
    unknown(f)

Returns true if the format of `f` is unknown.
"""
unknown(@nospecialize(f::Union{Formatted,Type})) = unknown(formatname(f)::Symbol)
unknown(name::Symbol) = name === :UNKNOWN

const unknown_df = DataFormat{:UNKNOWN}


"""
    info(fmt)

Returns the magic bytes/extension information for `fmt`.
"""
info(@nospecialize(f::Union{Formatted,Type})) = info(formatname(f)::Symbol)
info(sym::Symbol) = sym2info[sym]

"""
    magic(fmt)

Returns the magic bytes of format `fmt`
"""
magic(@nospecialize(fmt::Type)) = magic(formatname(fmt)::Symbol)
magic(sym::Symbol) = info(sym)[1]

"""
    skipmagic(s::Stream)

Sets the position of `s` to be just after the magic bytes.
For a plain IO object, you can use `skipmagic(io, fmt)`.
"""
skipmagic(@nospecialize(s::Stream)) = (skipmagic(stream(s), formatname(s)::Symbol); s)
skipmagic(io, @nospecialize(fmt::Type)) = skipmagic(io, formatname(fmt)::Symbol)
function skipmagic(io, sym::Symbol)
    magic, _ = sym2info[sym]
    skipmagic(io, magic)
    nothing
end
skipmagic(io, @nospecialize(magic::Function)) = nothing
skipmagic(io, magic::Vector{UInt8}) = seek(io, length(magic))
function skipmagic(io, magics::Vector{Vector{UInt8}})
    lengths = map(length, magics)
    l1 = lengths[1]
    all(isequal(l1), lengths) && return seek(io, l1) # it doesn't matter what magic bytes get skipped as they all have the same length
    len = getlength(io)
    tmp = read(io, min(len, maximum(lengths)))
    for m in reverse(magics)  # start with the longest since they are most specific
        if magic_equal(m, tmp)
            seek(io, length(m))
            return nothing
        end
    end
    error("tried to skip magic bytes of an IO that does not contain the magic bytes of the format. IO: $io")
end

function magic_equal(magic, buffer)
    length(magic) > length(buffer) && return false
    for (i,elem) in enumerate(magic)
        buffer[i] != elem && return false
    end
    true
end

function getlength(io, pos=position(io))
    seekend(io)
    len = position(io)
    seek(io, pos)
    return len
end

"""
    query(filename; checkfile=true)

Return a `File` object with information about the
format inferred from the file's extension and/or magic bytes.
If `filename` already exists, the file's magic bytes will take priority
unless `checkfile` is false.
"""
function query(filename; checkfile::Bool=true)
    filename = abspath(filename)
    sym = querysym(filename; checkfile=checkfile)
    return File{DataFormat{sym}}(filename)
end
query(@nospecialize(f::Formatted)) = f

# This is recommended for internal use because it returns Symbol (or errors)
function querysym(filename; checkfile::Bool=true)
    hasmagic(@nospecialize(magic)) = !(isa(magic, Vector{UInt8}) && isempty(magic))

    checkfile &= isfile(filename)
    _, ext = splitext(filename)
    if haskey(ext2sym, ext)
        sym = ext2sym[ext]
        if isa(sym, Symbol)               # there's only one format with this extension
            checkfile || return sym       # since we're not checking, we can return it immediately
            magic = sym2info[sym][1]
            hasmagic(magic) || return sym
            return open(filename) do io
                match(io, magic) && return sym
                # if it doesn't match, we prioritize the magic bytes over the guess based on extension
                fmt = querysym_all(io)[1]
                # but if it fails to query the magic bytes, still use the extension-based guess
                return fmt === :UNKNOWN ? sym : fmt
            end
        end
        # There are multiple formats consistent with this extension
        syms = sym::Vector{Symbol}
        checkfile || return syms[1]     # with !checkfile we default to the first. TODO?: change to an error?
        return open(filename) do io
            badmagic = false
            for sym in syms
                magic = sym2info[sym][1]
                if !hasmagic(magic)
                    badmagic = true
                    continue
                end
                match(io, magic) && return sym
            end
            badmagic && error("Some formats with extension ", ext,
                              " have no magic bytes; use `File{format\"FMT\"}(filename)` to resolve the ambiguity.")
            fmt = querysym_all(io)[1]
            return fmt === :UNKNOWN ? syms[1] : fmt
        end
    end
    !checkfile && return :UNKNOWN
    return open(filename) do io
        return querysym_all(io)[1]
    end
end

function match(io, magic::Vector{UInt8})
    len = getlength(io)
    len < length(magic) && return false
    return magic_equal(magic, read(io, length(magic)))
end

function match(io, magics::Vector{Vector{UInt8}})
    lengths = map(length, magics)
    len = getlength(io)
    tmp = read(io, min(len, maximum(lengths)))
    for m in reverse(magics)  # start with the longest since they are most specific
        if magic_equal(m, tmp)
            return true
        end
    end
    return false
end

function match(io, @nospecialize(magic::Function))
    seekstart(io)
    try
        magic(io)
    catch e
        @error("""There was an error in magic function $magic.
                  Please open an issue at FileIO.jl.""", exception=(e, catch_backtrace()))
        false
    end
end

# Returns sym, magic (the latter may be empty if a magic-function matched)
# Upon return the stream position is set to the end of magic.
function querysym_all(io)
    seekstart(io)
    len = getlength(io)
    lengths = map(magic_list) do p
        length(p.first)
    end
    tmp = read(io, min(len, maximum(lengths)))
    for (magic, sym) in reverse(magic_list)
        isempty(magic) && break
        if magic_equal(magic, tmp)
            seek(io, length(magic))
            return sym, magic
        end
    end
    for (magic, sym) in magic_func
        seekstart(io)
        match(io, magic) && return sym, empty_magic
    end
    seekstart(io)
    return :UNKNOWN, empty_magic
end

function querysym(io::IO)
    if seekable(io)
        sym, _ = querysym_all(io)
        seekstart(io)
        return sym
    end
    # When it's not seekable, we can only work our way upwards in length of magic bytes
    # We're essentially counting on the fact that one of them will match, otherwise the stream
    # is corrupted.
    buffer = UInt8[]
    for (magic, sym) in magic_list
        isempty(magic) && continue
        while length(buffer) < length(magic) && !eof(io)
            push!(buffer, read(io, UInt8))
        end
        if magic_equal(magic, buffer)
            return sym
        end
        eof(io) && break
    end
    return :UNKNOWN
end


"""
    query(io, [filename])

Returns a `Stream` object with information about the format inferred from the magic bytes.
"""
function query(io::IO, filename = nothing)
    sym = querysym(io)
    return Stream{DataFormat{sym}}(io, filename)
end
query(io::IO, @nospecialize(file::Formatted)) = Stream{DataFormat{formatname(file)::Symbol}}(io, filename(file))

seekable(io::IOBuffer) = io.seekable
seekable(::IOStream) = true
seekable(::Any) = false

"""
    LoaderError <: Exception

`LoaderError` should be thrown when loader library code fails, and other libraries should
be given the chance to recover from the error.  Reports the library name and an error message:
```julia
LoaderError("ImageMagick", "Foo not available")
```
"""
struct LoaderError <: Exception
    library::String
    msg::String
    ex
end
Base.showerror(io::IO, e::LoaderError) = println(IOContext(io, :limit=>true), e.library, " load error: ",
                                                 e.msg, "\n  due to ", e.ex, "\n  Will try next loader.")

"""
    WriterError <: Exception

`WriterError` should be thrown when writer library code fails, and other libraries should
be given the chance to recover from the error.  Reports the library name and an error message:
```julia
WriterError("ImageMagick", "Foo not available")
```
"""
struct WriterError <: Exception
    library::String
    msg::String
    ex
end
Base.showerror(io::IO, e::WriterError) = println(
    IOContext(io, :limit=>true), e.library, " writer error: ",
    e.msg, "\n  due to ", e.ex, "\n  Will try next loader."
)


struct SpecError <: Exception
    mod::Module
    call::Symbol
end
Base.showerror(io::IO, e::SpecError) = print(io, e.mod, " is missing $(e.call) and fileio_$(e.call)")

"""
    handle_exceptions(exceptions::Vector, action)

Handles a list of thrown errors after no IO library was found working
"""
function handle_exceptions(exceptions::Vector, action)
    # first show all errors when there are more then one
    multiple = length(exceptions) > 1
    println(stderr, "Error$(multiple ? "s" : "") encountered while $action.")
    if multiple
        println("All errors:")
        println("===========================================")
        for (err, file, bt) in exceptions
            showerror(stdout, err)
            println("\n===========================================")
        end
    end
    # then handle all errors.
    # this way first fatal exception throws and user can still see all errors
    # TODO, don't throw, if it contains a NotInstalledError?!
    println(stderr, "\nFatal error:")
    for exception in exceptions
        continue_ = handle_error(exception...)
        continue_ || break
    end
end

function handle_error(e, q, bt)
    if VERSION >= v"1.13.0-DEV.927"
        throw(CapturedException(e, bt))
    else
        throw(CapturedException(e, trim!(stacktrace(bt))))
    end
end

function trim!(sfs)
    i = firstindex(sfs)
    while i <= lastindex(sfs)
        sf = sfs[i]
        if Base.StackTraces.is_top_level_frame(sf)
            deleteat!(sfs, i+1:lastindex(sfs))
            break
        end
        i += 1
    end
    return sfs
end

module HTTPExt

if isdefined(Base, :get_extension)
    using FileIO
    using HTTP
else
    using ..FileIO
    using ..HTTP
end

FileIO.load(uri::HTTP.URI) = load(IOBuffer(HTTP.get(uri).body))
FileIO.metadata(uri::HTTP.URI) = metadata(IOBuffer(HTTP.get(uri).body))

end # module

println("these tests will print warnings: ")

module PathError
    import FileIO: File, @format_str
    save(file::File{format"PATHERROR"}, data) = nothing
    load(file::File{format"PATHERROR"}) = nothing
end
add_format(format"PATHERROR", (), ".patherror", [PathError])

@testset "Path errors" begin
    # handling a nonexistent parent directory, during save
    temp_dir = joinpath(mktempdir(), "dir_that_did_not_exist")
    @assert !isdir(temp_dir) "Testing error. This dir shouldn't exist"
    fn = joinpath(temp_dir, "file.patherror")
    save(fn, "test content")
    @test isdir(temp_dir)

    # handling a filepath that's an existing directory, during save
    @test_throws ArgumentError save(format"PATHERROR", mktempdir(), "test content")

    # handling a nonexistent filepath, during load
    @test_throws ArgumentError load(joinpath(mktempdir(), "dummy.patherror"))
end

@testset "Not installed" begin
    # The logging part of this test only works when running under Pkg.test (TODO: fix this)
    @test_logs (:warn, r"supply `pkg` as a Module or `name=>uuid`") @test_throws(ArgumentError, add_format(format"NotInstalled", (), ".not_installed", [:NotInstalled]))
    # Give it a fake UUID
    add_format(format"NotInstalled", (), ".not_installed", [:NotInstalled=>UUID("79e393ae-7a7b-11eb-1530-bf4d98024096")])
    @test_throws CapturedException save("test.not_installed", nothing)

    # Core.eval(Base, :(is_interactive = true)) # for interactive error handling
    # add_format(format"NotInstalled", (), ".not_installed", [:NotInstalled])
    # stdin_copy = stdin
    # stderr_copy = stderr
    # rs, wr = redirect_stdin()
    # rserr, wrerr = redirect_stderr()
    # ref = @async save("test.not_installed", nothing)
    # println(wr, "y")
    # @test_throws ArgumentError fetch(ref) #("unknown package NotInstalled")
    # ref = @async save("test.not_installed", nothing)
    # println(wr, "invalid") #test invalid input
    # println(wr, "n") # don't install
    # fetch(ref)
    # @test istaskdone(ref)

    # close(rs);close(wr);close(rserr);close(wrerr)
    # redirect_stdin(stdin_copy)
    # redirect_stderr(stderr_copy)

    # Core.eval(Base, :(is_interactive = false)) # for interactive error handling

end


# Missing load/save functions
module BrokenIO
    using FileIO
end
add_format(format"BROKEN", (), ".brok", [BrokenIO])

@testset "Absent implementation" begin
    stderr_copy = stderr
    rserr, wrerr = redirect_stderr()
    ex = try load(Stream{format"BROKEN"}(stdin)) catch e e end
    @test isa(ex, CapturedException)
    @test isa(ex.ex, FileIO.LoaderError)
    @test isa(ex.ex.ex, FileIO.SpecError)
    ex = try save(Stream{format"BROKEN"}(stdout), nothing) catch e e end
    @test isa(ex, CapturedException)
    @test isa(ex.ex, FileIO.WriterError)
    @test isa(ex.ex.ex, FileIO.SpecError)
    redirect_stderr(stderr_copy)
    close(rserr);close(wrerr)
end

module BrokenIO2
    using FileIO
    function save(f::File{format"BROKEN2"}, data)
        error("whoops")
    end
end
add_format(format"BROKEN2", (), ".brok2", [BrokenIO2])

@testset "Broken implementation/limit" begin
    io = IOBuffer()
    stderr_copy = stderr
    rserr, wrerr = redirect_stderr()
    ex = try save(Stream{format"BROKEN2"}(stdout), [1:1000;]) catch e e end
    @test isa(ex, CapturedException)
    @test isa(ex.ex, MethodError)
    showerror(io, ex)
    str = String(take!(io))
    @test startswith(str, "MethodError: no method matching save(::Stream{DataFormat{:BROKEN2}")
    exw = FileIO.WriterError("BrokenIO2", "a message", ex.ex)
    showerror(io, exw)
    str = String(take!(io))
    @test startswith(str, "BrokenIO2 writer error: a message\n  due to MethodError(")
    @test !occursin("499", str)   # printing should be with `:limit`
    @test  occursin("…", str)     # printing should be with `:limit`
    ex = try save(File{format"BROKEN2"}(tempname()), [1:1000;]) catch e e end
    @test isa(ex, CapturedException)
    @test ex.ex == ErrorException("whoops")
    showerror(io, ex)
    str = String(take!(io))
    @test !occursin("499", str)   # printing should be with `:limit`
    redirect_stderr(stderr_copy)
    close(rserr);close(wrerr)
end

module MultiError1
    import FileIO: @format_str, File
    load(file::File{format"MultiError"}) = error("1")
end
module MultiError2
    import FileIO: @format_str, File, magic
    load(file::File{format"MultiError"}) = error("2")
end
@testset "multiple errors" begin
    println("this test will print warnings: ")
    add_format(
        format"MultiError",
        (),
        ".multierr",
        [MultiError1],
        [MultiError2]
    )
    tmpfile = joinpath(mktempdir(), "test.multierr")
    open(tmpfile, "w") do io
        println(io, "dummy content")
    end
    ex = try load(tmpfile) catch e e end
    @test isa(ex, CapturedException)
    @test isa(ex.ex, ErrorException)
    rm(dirname(tmpfile), recursive=true)
end

@testset "stacktrace trimming" begin
    sfs = try
        error("whoops")
    catch err
        stacktrace(catch_backtrace())
    end
    n = length(sfs)
    FileIO.trim!(sfs)
    @test length(sfs) < 5 < n
end

module BustedME
using FileIO
load(file, args...) = foo()
add_format(format"BUSTEDME", "BUSTEDME", ".bus", [BustedME])
end
@testset "error accuracy" begin
    tmpfile = joinpath(mktempdir(), "test.bus")
    open(tmpfile, "w") do io
        write(io, magic(format"BUSTEDME"))
        println(io, "dummy content")
    end
    ex = try load(tmpfile) catch e e end
    @test isa(ex, CapturedException)
    @test isa(ex.ex, UndefVarError)
    rm(dirname(tmpfile), recursive=true)
end

### "Package registry"
# Useful for packages that get used more than once below
# Please alphabetize
const idAVSfldIO = :AVSfldIO => UUID("b6189060-daf9-4c28-845a-cc0984b81781")
const idCSVFiles = :CSVFiles => UUID("5d742f6a-9f54-50ce-8119-2520741973ca")
const idImageIO = :ImageIO => UUID("82e4d734-157c-48bb-816b-45c225c6df19")
const idImageMagick = :ImageMagick => UUID("6218d12a-5da1-5696-b52f-db25d2ecc6d1")
const idMeshIO = :MeshIO => UUID("7269a6da-0436-5bbc-96c2-40638cbb6118")
const idNetpbm = :Netpbm => UUID("f09324ee-3d7c-5217-9330-fc30815ba969")
const idOpenCV = :OpenCV => UUID("f878e3a2-a245-4720-8660-60795d644f2a")
const idRData = :RData => UUID("df47a6cb-8c03-5eed-afd8-b6050d6c41da")
const idStatFiles = :StatFiles => UUID("1463e38c-9381-5320-bcd4-4134955f093a")
const idSixel = :Sixel => UUID("45858cf5-a6b0-47a3-bbea-62219f50df47")
const idVegaLite = :VegaLite => UUID("112f6efa-9a02-5b7d-90c0-432ed331239a")
const idVideoIO = :VideoIO => UUID("d6d074c3-1acf-5d4c-9a43-ef38773959a2")
const idLibSndFile = :LibSndFile => UUID("b13ce0c6-77b0-50c6-a2db-140568b8d1a5")
const idJpegTurbo = :JpegTurbo => UUID("b835a17e-a41a-41e7-81f0-2f016b05efe0")
const idNPZ = :NPZ => UUID("15e1cf62-19b3-5cfa-8e77-841668bca605")
const idUFFFiles = :UFFFiles => UUID("20c5726e-8372-4c34-be2c-190a5a70d483")

# Cf. https://developers.google.com/speed/webp/docs/riff_container#riff_file_format, and https://learn.microsoft.com/en-us/windows/win32/xaudio2/resource-interchange-file-format--riff-#chunks
function detect_riff(io::IO, expected_magic::AbstractVector{UInt8})
    getlength(io) >= 12 || return false
    buf = Vector{UInt8}(undef, 4)
    fourcc = read!(io, buf)
    fourcc == b"RIFF" || return false
    seek(io, 8)
    magic = read!(io, buf)
    return magic == expected_magic
end

### Simple cases

# data formats
add_format(format"JLD", (unsafe_wrap(Vector{UInt8}, "Julia data file (HDF5), version 0.0"),
                         unsafe_wrap(Vector{UInt8}, "Julia data file (HDF5), version 0.1")),
           ".jld", [:JLD => UUID("4138dd39-2aa7-5051-a626-17a0bb65d9c8")])
add_format(format"JLD2", (unsafe_wrap(Vector{UInt8},"Julia data file (HDF5), version 0.2"),
                          unsafe_wrap(Vector{UInt8}, "HDF5-based Julia Data Format, version ")),
           ".jld2", [:JLD2 => UUID("033835bb-8acc-5ee8-8aae-3f567f8a3819")])
add_format(format"BSON", (), ".bson", [:BSON => UUID("fbb218c0-5317-5bc6-957e-2ee96dd4b1f0")])
add_format(format"JLSO", (), ".jlso", [:JLSO => UUID("9da8a3cd-07a3-59c0-a743-3fdc52c30d11")])
add_format(format"MAT", (), ".mat", [:MAT => UUID("23992714-dd62-5051-b70f-ba57cb901cac")])
add_format(format"NPY", "\x93NUMPY", ".npy", [idNPZ])
add_format(format"NPZ", "PK\x03\x04", ".npz", [idNPZ])

function detect_compressor(io, len=getlength(io); formats=["GZIP", "BZIP2", "XZ", "LZ4"])
    seekstart(io)
    len < 2 && return nothing
    b1 = read(io, UInt8)
    b2 = read(io, UInt8)
    if "GZIP" ∈ formats
        b1 == 0x1f && b2 == 0x8b && return "GZIP"
    end
    len < 3 && return nothing
    b3 = read(io, UInt8)
    if "BZIP2" ∈ formats
        b1 == 0x42 && b2 == 0x5A && b3 == 0x68 && return "BZIP2"
    end
    len < 4 && return nothing
    b4 = read(io, UInt8)
    if "LZ4" ∈ formats
        b1 == 0x04 && b2 == 0x22 && b3 == 0x4D && b4 == 0x18 && return "LZ4"
    end
    len < 5 && return nothing
    b5 = read(io, UInt8)
    len < 6 && return nothing
    b6 = read(io, UInt8)
    if "XZ" ∈ formats
        b1 == 0xFD && b2 == 0x37 && b3 == 0x7A && b4 == 0x58 && b5 == 0x5A && b6 == 0x00 && return "XZ"
    end
    return nothing
end

detect_compressed(io, len=getlength(io); kwargs...) = detect_compressor(io, len; kwargs...) !== nothing

const compressed_fits_exten = r"\.(fit|fits|fts|FIT|FITS|FTS)\.(gz|GZ)\>"
name_matches_compressed_fits(io) = (:name ∈ propertynames(io)) && endswith(io.name, compressed_fits_exten)

# test for RD?n magic sequence at the beginning of R data input stream
function detect_rdata(io)
    seekstart(io)
    function checked_match(io)
        for m in (
                (UInt8('R'), ),
                (UInt8('D'), ),
                (UInt8('A'), UInt8('B'), UInt8('X')),
                (UInt8('2'), UInt8('3')))
            eof(io) && return false
            read(io, UInt8) in m || return false
        end
        c = read(io, UInt8)
        if c == UInt8('\r')
            eof(io) && return false
            c = read(io, UInt8)
        end
        c == UInt8('\n') || return false
        return true
    end
    checked_match(io) && return true
    return detect_compressed(io; formats=["GZIP", "BZIP2", "XZ"]) && !name_matches_compressed_fits(io)
end

add_format(format"RData", detect_rdata, [".rda", ".RData", ".rdata"], [idRData, LOAD])

function detect_rdata_single(io)
    seekstart(io)
    function checked_match(io)
        eof(io) && return false
        read(io, UInt8) in (UInt8('A'), UInt8('B'), UInt8('X')) || return false
        c = read(io, UInt8)
        if c == UInt8('\r')
            eof(io) && return false
            c = read(io, UInt8)
        end
        c == UInt8('\n') || return false
        return true
    end

    res = checked_match(io)
    if !res
        res = detect_compressed(io; formats=["GZIP", "BZIP2", "XZ"]) && !name_matches_compressed_fits(io)
    end
    seekstart(io)
    return res
end

function detect_excel(io)
    # All OOXML Excel files are ZIPs starting with PK\x03\x04
    magic = try
        read(io, 4)
    catch
        return false
    end
    magic == UInt8[0x50, 0x4b, 0x03, 0x04]
    # Note: a more precise check would unzip and inspect [Content_Types].xml,
    # but the extension list already constrains to Excel extensions,
    # so just claiming the ZIP magic is sufficient to beat NPZ.
end

add_format(format"RDataSingle", detect_rdata_single, [".rds"], [idRData, LOAD])

add_format(format"AVSfld", "# AVS", [".fld"], [idAVSfldIO])
add_format(format"CSV", (), [".csv"], [idCSVFiles])
add_format(format"TSV", (), [".tsv"], [idCSVFiles])
add_format(format"Feather", "FEA1", [".feather"], [:FeatherFiles => UUID("b675d258-116a-5741-b937-b79f054b0542")])
add_format(format"Arrow", b"ARROW1\0\0", [".arrow"], [:Arrow => UUID("69666777-d1a9-59fb-9406-91d4454c9d45")])
add_format(format"Excel", detect_excel, [".xlsx", ".xltx", ".xlsm", ".xltm"], [:XLSX => UUID("fdbf4ff8-1666-58a4-91e7-1b58723a45e0")])
add_format(format"Stata", (), [".dta"], [idStatFiles, LOAD])
add_format(format"SPSS", "\$FL2", [".sav"], [idStatFiles, LOAD])
add_format(format"SAS", UInt8[0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xc2, 0xea, 0x81, 0x60,0xb3, 0x14, 0x11,
    0xcf, 0xbd, 0x92, 0x08, 0x00, 0x09, 0xc7, 0x31, 0x8c, 0x18, 0x1f,
    0x10, 0x11], [".sas7bdat"], [idStatFiles, LOAD])
add_format(format"Parquet", "PAR1", [".parquet"], [:ParquetFiles => UUID("46a55296-af5a-53b0-aaa0-97023b66127f"), LOAD])

# Image formats
add_format(format"PBMBinary", "P4", ".pbm", [idImageIO], [idNetpbm], [idImageMagick])
add_format(format"PGMBinary", "P5", ".pgm", [idImageIO], [idNetpbm])
add_format(format"PPMBinary", "P6", ".ppm", [idImageIO], [idNetpbm])
add_format(format"PBMText",   "P1", ".pbm", [idImageIO], [idNetpbm], [idImageMagick, LOAD])
add_format(format"PGMText",   "P2", ".pgm", [idImageIO], [idNetpbm], [idImageMagick, LOAD])
add_format(format"PPMText",   "P3", ".ppm", [idImageIO], [idNetpbm], [idImageMagick, LOAD])

add_format(format"NRRD", "NRRD", [".nrrd", ".nhdr"], [:NRRD => UUID("9bb6cfbd-7763-5393-b1b5-1c8e09872146")])

add_format(format"AndorSIF", "Andor Technology Multi-Channel File", ".sif", [:AndorSIF => UUID("d04cd5f8-5917-4006-ac6f-d139328806a7"), LOAD])

add_format(format"FLO", "PIEH", ".flo", [:OpticalFlowUtils => UUID("ab0dad50-ab19-448c-b796-13553ec8b2d3")])

add_format(format"CRW", UInt8[0x49,0x49,0x1a,0x00,0x00,0x00,0x48,0x45], ".crw", [idImageMagick])
add_format(format"CUR", UInt8[0x00,0x00,0x02,0x00],                     ".cur", [idImageMagick])
add_format(format"DCX", UInt8[0xb1,0x68,0xde,0x3a],                     ".dcx", [idImageMagick])
add_format(format"DOT", UInt8[0xd0,0xcf,0x11,0xe0,0xa1,0xb1,0x1a,0xe1], ".dot", [idImageMagick])
add_format(format"EPS", UInt8[0x25,0x21,0x50,0x53,0x2d,0x41,0x64,0x6f], ".eps", [idImageMagick], [MimeWriter, SAVE])
add_format(format"EXR", UInt8[0x76,0x2f,0x31,0x01],                     ".exr", [idImageIO])
add_format(format"HDR", UInt8[0x23,0x3f,0x52,0x41,0x44,0x49,0x41,0x4e], ".hdr", [idImageMagick])
add_format(format"ICO", UInt8[0x00,0x00,0x01,0x00],                     ".ico", [idImageMagick])
add_format(format"INFO", UInt8[0x7a,0x62,0x65,0x78],                    ".info",[idImageMagick])
add_format(format"JP2", UInt8[0x00,0x00,0x00,0x0c,0x6a,0x50,0x20,0x20], ".jp2", [idImageMagick], [idOpenCV])
add_format(format"PDB", UInt8[0x73,0x7a,0x65,0x7a],                     ".pdb", [idImageMagick])
add_format(format"PDF", UInt8[0x25,0x50,0x44,0x46],                     ".pdf", [idImageMagick], [MimeWriter, SAVE])
add_format(format"PGM", UInt8[0x50,0x35,0x0a],                          ".pgm", [idImageMagick])
add_format(format"PSD", UInt8[0x38,0x42,0x50,0x53],                     ".psd", [idImageMagick])
add_format(format"RGB", UInt8[0x01,0xda,0x01,0x01,0x00,0x03],           ".rgb", [idImageMagick])
add_format(format"WMF", UInt8[0xd7,0xcd,0xc6,0x9a],                     ".wmf", [idImageMagick])
add_format(format"WPG", UInt8[0xff,0x57,0x50,0x43],                     ".wpg", [idImageMagick])
add_format(format"Imagine", "IMAGINE",                                  ".imagine", [:ImagineFormat => UUID("4bab44a2-5ff2-5a6b-8e10-825fb9ac126a")])

add_format(
    format"TGA",
    (),
    ".tga",
    [idImageMagick]
)
add_format(
    format"GIF",
    UInt8[0x47,0x49,0x46,0x38],
    ".gif",
    [idImageMagick]
)
add_format(
    format"PNG",
    UInt8[0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a],
    ".png",
    [idImageIO],
    [idImageMagick],
    [idOpenCV],
    [MimeWriter, SAVE]
)
add_format(
    format"JPEG",
    UInt8[0xff,0xd8,0xff],
    [".jpeg", ".jpg", ".JPG"],
    [idJpegTurbo],
    [idImageIO],
    [idImageMagick],
    [idOpenCV]
) # 0xe1
add_format(
    format"BMP",
    UInt8[0x42,0x4d],
    ".bmp",
    [idImageMagick],
    [idOpenCV]
)
add_format(
    format"PCX",
    (UInt8[0x0a,0x02], UInt8[0x0a,0x05]),
    ".pcx",
    [idImageMagick]
)
add_format(
    format"QOI",
    "qoif",
    ".qoi",
    [:QOI => UUID("4b34888f-f399-49d4-9bb3-47ed5cae4e65")],
    [idImageIO]
)
add_format(
    format"SVG",
    (),
    ".svg",
    [MimeWriter, SAVE]
)
add_format(
    format"SIXEL",
    UInt8[0x1b, 0x50, 0x71],
    [".sixel", ".six"],
    [idSixel],
    [idImageIO],
    [idImageMagick]
)
detect_webp(io) = detect_riff(io, b"WEBP")
add_format(
    format"WebP",
    detect_webp,
    ".webp",
    [:WebP => UUID("e3aaa7dc-3e4b-44e0-be63-ffb868ccd7c1")],
    [idImageIO]
)

# Video formats

detectavi(io) = detect_riff(io, b"AVI ")
add_format(format"AVI", detectavi, ".avi", [idImageMagick], [idVideoIO])

"""
    detectisom(io)

Detect ISO/IEC 14496-12 ISO/IEC base media format files. These files start with
a 32-bit big-endian length, and then the string 'ftyp' which is followed by
details of the container and codec. Finding 'ftyp' is enough to know to dispatch
to VideoIO.
"""
function detectisom(io)
    getlength(io) >= 8 || return false
    # skip the length bytes
    seek(io, 4)
    # and check for the magic
    magic = read!(io, Vector{UInt8}(undef, 4))
    magic == b"ftyp"
end
add_format(format"MP4", detectisom, ".mp4", [idVideoIO])
add_format(format"OGG", UInt8[0x4F,0x67,0x67,0x53], [".ogg",".ogv"], [idVideoIO], [idLibSndFile])
add_format(format"MATROSKA", UInt8[0x1A,0x45,0xDF,0xA3], [".mkv",".mks",".webm"], [idVideoIO])

#=
add_format(format"NPY", UInt8[0x93, 'N', 'U', 'M', 'P', 'Y'], ".npy")
add_loader(format"NPZ", :NPZ)
add_saver(format"NPZ", :NPZ)

add_format(format"ZIP", [0x50,0x4b,0x03,0x04], ".zip")
add_loader(format"ZIP", :ZipeFile)
add_saver(format"ZIP", :ZipeFile)
=#

# Mesh formats
add_format(format"OBJ", (), ".obj", [idMeshIO])
add_format(format"PLY_ASCII", "ply\nformat ascii 1.0", ".ply", [idMeshIO])
add_format(format"PLY_BINARY", "ply\nformat binary_little_endian 1.0", ".ply", [idMeshIO])
add_format(format"2DM", "MESH2D", ".2dm", [idMeshIO])
add_format(format"OFF", "OFF", ".off", [idMeshIO])
add_format(format"MSH", (), ".msh", [idMeshIO])
add_format(format"INP", (), ".inp", [idMeshIO])

# Bundler SfM format
add_format(format"OUT", "# Bundle file v0.3\n", ".out", [:BundlerIO => UUID("654bb1e1-1cb7-4447-b770-09a16346af94")])

# GSLIB/SGeMS format (http://gslib.com)
add_format(format"GSLIB", (), [".gslib",".sgems"], [:GslibIO => UUID("4610876b-9b01-57c8-9ad9-06315f1a66a5")])

### Audio formats
detectwav(io) = detect_riff(io, b"WAVE")
add_format(format"WAV", detectwav, ".wav", [:WAV => UUID("8149f6b0-98f6-5db9-b78f-408fbbb8ef88")], [idLibSndFile])
add_format(format"FLAC", "fLaC", ".flac", [:FLAC => UUID("abae9e3b-a9a0-4778-b5c6-ca109b507d99")], [idLibSndFile])
add_format(format"AIFF", "FORM", [".aif", ".aiff"], [idLibSndFile])

## Profile data
add_format(
    format"JLPROF",
    [0x4a, 0x4c, 0x50, 0x52, 0x4f, 0x46, 0x01, 0x00],
    ".jlprof",
    [:FlameGraphs => UUID("08572546-2f56-4bcf-ba4e-bab62c3a3f89")]
)  # magic is "JLPROF" followed by [0x01, 0x00]

### Complex cases

#=
The bedGraph file format is line-based, and its magic bytes may occur at an indeterminate location within its header.
Certain conditions must be imposed to constrain the scan for its magic bytes and prevent unnecessary scanning of whole files.
Lines must start with particular byte strings that are recognisable to the bedGraph format to allow the scan for its magic bytes to continue.
=#
function detect_bedgraph(io)

    bedgraph_magic = b"type=bedGraph"

    # Line start constraints.
    browser_magic = b"browser"
    track_magic   = b"track"
    comment_magic = b"#"

    keep_scanning = false # Allow scan to continue until new line.
    ontrack = false # On the track that may contain the magic bytes.

    # Check lines for magic bytes.
    pos = 1
    while !eof(io)
        r = read(io, UInt8)

        # Check whether the line starts with a comment.
        if !keep_scanning && pos == 1 && comment_magic[pos] == r
            keep_scanning = true # Now scanning for newline.
            pos += 1
            continue
        end

        # Check whether the line starts with "browser".
        if !keep_scanning && browser_magic[pos] == r
            if pos >= length(browser_magic)
                keep_scanning = true # Now scanning for newline.
            end
            pos += 1
            continue
        end

        # Check whether the line starts with "track".
        if !keep_scanning && track_magic[pos] == r
            if pos >= length(track_magic)
                ontrack = true # Found the "track" line where the magic bytes may exist.
                keep_scanning = true # Allow scan to continue until the end of the current line.
            end
            pos += 1
            continue
        end

        # Check whether the line has ended.
        if UInt8('\n') == r
            keep_scanning = false
            ontrack = false
            pos = 1
            continue
        end

        # On "track" and checking whether "type=bedGraph" is contained within the line.
        if ontrack && bedgraph_magic[pos] == r
            pos >= length(bedgraph_magic) && return true
            pos += 1
            continue
        end

        pos = 1

        # Allow whitespace.
        if UInt8('\t') == r || UInt8(' ') == r
            continue
        end

        # Check whether on "track" and allowed to continue scanning.
        if !keep_scanning && !ontrack
            break # Ending scan for bedGraph magic.
        end

    end

    return false
end
add_format(format"bedGraph", detect_bedgraph, [".bedgraph"], [:BedgraphFiles => UUID("85eb9095-274b-55ce-be28-9e90f41ac741")])

# Handle OME-TIFFs, which are identical to normal TIFFs with the primary difference being the filename and embedded XML metadata
const tiff_magic = (UInt8[0x4d,0x4d,0x00,0x2a], UInt8[0x4d,0x4d,0x00,0x2b],
                    UInt8[0x49,0x49,0x2a,0x00], UInt8[0x49,0x49,0x2b,0x00])
function detecttiff(io)
    getlength(io) >= 4 || return false
    magic = read!(io, Vector{UInt8}(undef, 4))
    # do any of the first 4 bytes match any of the 4 possible combinations of tiff magics
    return any(map(x->all(magic .== x), tiff_magic))
end
# normal TIFF
detect_noometiff(io) = detecttiff(io) && ((:name ∉ propertynames(io)) || !(endswith(io.name, ".ome.tif>") || endswith(io.name, ".ome.tiff>")))
add_format(format"TIFF", detect_noometiff, [".tiff", ".tif"], [idImageIO], [idImageMagick], [idOpenCV])
# OME-TIFF
detect_ometiff(io) = detecttiff(io) && (:name ∈ propertynames(io)) && (endswith(io.name, ".ome.tif>") || endswith(io.name, ".ome.tiff>"))
add_format(format"OMETIFF", detect_ometiff, [".tif", ".tiff"], [:OMETIFF => UUID("2d0ec36b-e807-5756-994b-45af29551fcf")])

# custom skipmagic functions for function-based tiff magic detection
skipmagic(io, ::typeof(detect_ometiff)) = seek(io, 4)
skipmagic(io, ::typeof(detect_noometiff)) = seek(io, 4)

# DICOM: DICOM files should begin with a 128-bytes (which are ignored) followed by the string DICM
const dicommagic = UInt8['D', 'I', 'C', 'M']
function detectdicom(io)
    len = getlength(io)
    len < 132 && return false
    magic = Vector{UInt8}(read(io, 132)[end-3:end])
    magic == dicommagic
end
add_format(format"DCM", detectdicom, [".dcm"], [:ImageMagick => UUID("6218d12a-5da1-5696-b52f-db25d2ecc6d1")])

# HDF5: the complication is that the magic bytes may start at
# 0, 512, 1024, 2048, or any multiple of 2 thereafter
const h5magic = [0x89,0x48,0x44,0x46,0x0d,0x0a,0x1a,0x0a]
function detecthdf5(io)
    position(io) == 0 || return false
    len = getlength(io)
    magic = Vector{UInt8}(undef, length(h5magic))
    pos = position(io)
    while pos+length(h5magic) <= len
        read!(io, magic)
        if magic == h5magic
            return true
        end
        pos = pos == 0 ? 512 : 2*pos
        if pos < len
            seek(io, pos)
        end
    end
    false
end

const MUDATA_MAGIC = UInt8['M', 'u', 'D', 'a', 't', 'a']
function detect_mudata(io)
    seekstart(io)
    if read(io, 6) != MUDATA_MAGIC
        return false
    end
    seekstart(io)
    return detecthdf5(io)
end

# h5mu has to be before HDF5 to give it higher priority, since h5mu files are also valid HDF5 files
add_format(format"h5mu", detect_mudata, [".h5mu"], [:Muon => UUID("446846d7-b4ce-489d-bf74-72da18fe3629")])

add_format(format"HDF5", detecthdf5, [".h5", ".hdf5"], [:HDF5 => UUID("f67ccb44-e63f-5c2f-98bd-6dc0ccc4ba2f")])

# h5ad has to be after HDF5 to give it less priority
add_format(format"h5ad", detecthdf5, [".h5ad"], [:Muon => UUID("446846d7-b4ce-489d-bf74-72da18fe3629")])

function detect_stlascii(io)
    pos = position(io)
    try
        len = getlength(io, pos)
        len < 80 && return false
        header = read(io, 80) # skip header
        seek(io, pos)
        header[1:6] == b"solid " && !detect_stlbinary(io)
    finally
        seek(io, pos)
    end
end

function detect_stlbinary(io)
    size_header = 80 + sizeof(UInt32)
    size_triangleblock = (4 * 3 * sizeof(Float32)) + sizeof(UInt16)
    pos = position(io)
    len = getlength(io, pos)
    len < size_header && return false

    skip(io, 80) # skip header
    number_of_triangle_blocks = read(io, UInt32)
     #1 normal, 3 vertices in Float32 + attrib count, usually 0
    len != (number_of_triangle_blocks*size_triangleblock)+size_header && (seekstart(io); return false)
    skip(io, number_of_triangle_blocks*size_triangleblock)
    result = eof(io) # if end of file, we have a stl!
    return result
end
add_format(format"STL_ASCII", detect_stlascii, [".stl", ".STL"], [idMeshIO])
add_format(format"STL_BINARY", detect_stlbinary, [".stl", ".STL"], [idMeshIO])

# GZip has two simple magic bytes [0x1f, 0x8b] but we don't want to dispatch to Libz
# for file extensions like .fits.gz
function detect_gzip(io)
    if name_matches_compressed_fits(io)
        return false
    end
    getlength(io) >= 2 || return false
    magic = read!(io, Vector{UInt8}(undef, 2))
    return magic == [0x1f, 0x8b]
end
add_format(format"GZIP", detect_gzip, ".gz", [:Libz => UUID("2ec943e9-cfe8-584d-b93d-64dcb6d567b7")])


# Astro Data
# FITS files are often gziped and given the extension ".fits.gz". We want to load those directly and not dispatch to Libz
function detect_fits(io)
    # FITS files can have
    if name_matches_compressed_fits(io)
        return true
    end
    getlength(io) >= 30 || return false
    magic = read!(io, Vector{UInt8}(undef, 30))
    return magic == [0x53,0x49,0x4d,0x50,0x4c,0x45,0x20,0x20,0x3d,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x54]
end
add_format(format"FITS",
        # See https://www.loc.gov/preservation/digital/formats/fdd/fdd000317.shtml#sign
        # [0x53,0x49,0x4d,0x50,0x4c,0x45,0x20,0x20,0x3d,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x54],
        detect_fits,
        [".fit", ".fits", ".fts", ".FIT", ".FITS", ".FTS", ".fit",],
        [:FITSIO => UUID("525bcba6-941b-5504-bd06-fd0dc1a4d2eb")],
        [:AstroImages => UUID("fe3fc30c-9b16-11e9-1c73-17dabf39f4ad")])

add_format(format"ASDF",
        # See https://www.asdf-format.org/projects/asdf-standard/en/latest/file_layout.html#header
        # #ASDF == ([0x23,0x41,0x53,0x44,0x46])
        [0x23,0x41,0x53,0x44,0x46],
        [".asdf"],
        [:ASDF => UUID("686f71d1-807d-59a4-a860-28280ea06d7b")])

function detect_gadget2(io)
    pos = position(io)
    seekend(io)
    len = position(io)
    len > 264 || return false # at least 256 Header + 2 * Int32
    seek(io, pos) # Return to start
    temp1 = read(io, Int32)
    seek(io, sizeof(Int32)+256)
    temp2 = read(io, Int32)
    seek(io, pos)
    return temp1 == temp2 == 256
end
add_format(format"Gadget2", detect_gadget2, [".gadget2", ".Gadget2", ".GADGET2"], [:AstroIO => UUID("c85a633c-0c3f-44a2-bffe-7f9d0681b3e7")])

add_format(format"RawArray", [0x61,0x72,0x61,0x77,0x72,0x72,0x79,0x61], ".ra", [:RawArray => UUID("d3d335b2-f152-507c-820e-958e337efb65")])

add_format(format"MetaImage", "ObjectType", ".mhd", [:MetaImageFormat => UUID("1950589f-4d68-56f0-9b94-9d8646217309")])

add_format(format"vegalite", (), [".vegalite"], [idVegaLite])
add_format(format"vega", (), [".vega"], [:Vega => UUID("239c3e63-733f-47ad-beb7-a12fde22c578")], [idVegaLite, SAVE])

add_format(format"FCS", "FCS", [".fcs"], [:FCSFiles => UUID("d76558cf-badf-52d4-a17e-381ab0b0d937")])

add_format(format"HTML", (), [".html", ".htm"], [MimeWriter, SAVE])

add_format(format"MIDI", "MThd", [".mid", ".midi", ".MID"], [:MIDI => UUID("f57c4921-e30c-5f49-b073-3f2f2ada663e")])

# Bibliography files.
add_format(format"BIB", (), [".bib"], [:Bibliography => UUID("f1be7e48-bf82-45af-a471-ae754a193061")])

# sparse matrices
add_format(format"SMS", (), ".sms", [:SpaSM => UUID("017bf598-072c-475c-a75e-c3e68736ce70")])

# Hanoi Omega-Automata. Header is "HOA:"
add_format(format"HOA", UInt8[0x48,0x4f,0x41,0x3a], ".hoa", [:Buchi => UUID("484f28d2-1a9e-4e02-bb9b-910131567e8f")])

# BA "Buchi Automata" format, see https://languageinclusion.org/doku.php?id=tools#the_ba_format, used by
# FORKLIST https://github.com/Mazzocchi/FORKLIFT
# RABIT https://languageinclusion.org/doku.php?id=tools
# GOAL http://goal.im.ntu.edu.tw/wiki/doku.php
# ROLL https://iscasmc.ios.ac.cn/roll/doku.php?id=start
add_format(format"BA", (), ".ba", [:Buchi => UUID("484f28d2-1a9e-4e02-bb9b-910131567e8f")])

# UFF (Universal File Format) files
add_format(format"UFF", (), [".uff", ".unv", ".uf", ".bunv", ".ufb", ".buf"], [idUFFFiles])

module MimeWriter

using ..FileIO: File, @format_str

function save(file::File{format"PNG"}, data; ppi::Union{Nothing,Number}=nothing)
    if showable("image/png", data)
        open(file.filename, "w") do s
            if ppi === nothing
                show(IOContext(s, :full_fidelity=>true), "image/png", data)
            else
                show(IOContext(s, :full_fidelity=>true, :ppi=>ppi), "image/png", data)
            end
        end
    else
        throw(ArgumentError("Argument does not support conversion to png."))
    end
end

function save(file::File{format"SVG"}, data)
    if showable("image/svg+xml", data)
        open(file.filename, "w") do s
            show(IOContext(s, :full_fidelity=>true), "image/svg+xml", data)
        end
    else
        throw(ArgumentError("Argument does not support conversion to svg."))
    end
end

function save(file::File{format"PDF"}, data)
    if showable("application/pdf", data)
        open(file.filename, "w") do s
            show(IOContext(s, :full_fidelity=>true), "application/pdf", data)
        end
    else
        throw(ArgumentError("Argument does not support conversion to pdf."))
    end
end

function save(file::File{format"EPS"}, data)
    if showable("application/eps", data)
        open(file.filename, "w") do s
            show(IOContext(s, :full_fidelity=>true), "application/eps", data)
        end
    else
        throw(ArgumentError("Argument does not support conversion to eps."))
    end
end

function save(file::File{format"HTML"}, data)
    if showable("application/vnd.julia.fileio.htmlfile", data)
        open(file.filename, "w") do s
            show(s, "application/vnd.julia.fileio.htmlfile", data)
        end
    elseif showable("text/html", data)
        open(file.filename, "w") do s
            show(s, "text/html", data)
        end
    else
        throw(ArgumentError("Argument does not support conversion to HTML."))
    end
end

end

using FileIO
using Test
using Random
import Downloads

@testset "OS" begin
    if Sys.islinux()
        @test FileIO.applies_to_os(FileIO.Linux)
        @test !(FileIO.applies_to_os(FileIO.OSX))
        @test FileIO.applies_to_os(FileIO.Unix)
        @test !(FileIO.applies_to_os(FileIO.Windows))
    end
    if Sys.isapple()
        @test !(FileIO.applies_to_os(FileIO.Linux))
        @test FileIO.applies_to_os(FileIO.OSX)
        @test FileIO.applies_to_os(FileIO.Unix)
        @test !(FileIO.applies_to_os(FileIO.Windows))
    end
    if Sys.iswindows()
        @test !(FileIO.applies_to_os(FileIO.Linux))
        @test !(FileIO.applies_to_os(FileIO.OSX))
        @test !(FileIO.applies_to_os(FileIO.Unix))
        @test FileIO.applies_to_os(FileIO.Windows)
    end
end

module LoadTest1
    import FileIO: @format_str, File
    load(file::File{format"MultiLib"}) = error()
    save(file::File{format"MultiLib"}, data) = open(file, "w") do s
        write(s, magic(format"MultiLib"))  # Write the magic bytes
        write(s, 0)
    end
end

module LoadTest2
    import FileIO: @format_str, File, magic
    load(file::File{format"MultiLib"}) = 42
    save(file::File{format"MultiLib"}, data) = open(file, "w") do s
        write(s, magic(format"MultiLib"))  # Write the magic bytes
        write(s, 42)
    end
end

@testset "Double register" begin
    add_format(format"JUNK", "JUNK", [".jnk",".junk",".JNK"])
    @test_throws Exception add_format(format"JUNK2","JUNK",".jnk2") # magic bytes already registered
    del_format(format"JUNK")  # This triggers del_extension for multiple extensions
end

@testset "Format with function for magic bytes" begin
    add_format(format"FUNCTION_FOR_MAGIC_BYTES", io -> true, ".wav", [LoadTest1])
    del_format(format"FUNCTION_FOR_MAGIC_BYTES")
end

@testset "Fake registry" begin
    # Before we bork things, make a copy
    ext2sym = copy(FileIO.ext2sym)
    magic_list = copy(FileIO.magic_list)
    sym2info = copy(FileIO.sym2info)

    try
        empty!(FileIO.ext2sym)
        empty!(FileIO.magic_list)
        empty!(FileIO.sym2info)

        @testset "DataFormat" begin
            @test DataFormat{:CSV} == format"CSV"
            @test !(unknown(format"CSV"))
            @test unknown(format"UNKNOWN")

            add_format(format"CSV", UInt8[], ".csv")
            @test FileIO.info(format"CSV") == ([],".csv")
            add_format(format"FOO", (), ".foo")  # issue #17
            @test_throws Exception FileIO.info(format"OOPS")
            @test FileIO.ext2sym[".csv"] == :CSV
            del_format(format"FOO")
            @test FileIO.magic_list == [Pair([],:CSV)]
            del_format(format"CSV")
            @test isempty(FileIO.ext2sym)
            @test isempty(FileIO.magic_list)
            @test isempty(FileIO.sym2info)
            @test_throws Exception FileIO.info(format"CSV")

            add_format(format"JUNK", "JUNK", [".jnk",".junk",".JNK"])

            @test FileIO.info(format"JUNK") == (b"JUNK",[".jnk",".junk",".JNK"])
            @test FileIO.ext2sym[".jnk"] == :JUNK
            @test FileIO.ext2sym[".junk"] == :JUNK
            @test FileIO.ext2sym[".JNK"] == :JUNK
            @test FileIO.magic_list == [Pair([0x4a,0x55,0x4e,0x4b],:JUNK)]

            add_format(format"OTHER", [0x01, 0x02], ".othr")
        end

        @testset "streams" begin
            io = IOBuffer()
            s = Stream{format"JUNK"}(io)
            @test typeof(s) <: Stream{DataFormat{:JUNK},IOBuffer}
            @test filename(s) == nothing
            @test_throws ErrorException("filename unknown") FileIO.file!(s)
            s = Stream{format"JUNK"}(io, "junk.jnk")
            @test filename(s) == "junk.jnk"
            s = Stream{format"JUNK"}(io, "junk2.jnk")
            @test filename(s) == "junk2.jnk"
            s = Stream{format"JUNK"}(io, "somefile.jnk")
            @test FileIO.file!(s) isa File{format"JUNK"}
        end

        @testset "query" begin
            # Streams
            io = IOBuffer()
            write(io, "Weird format")
            seek(io, 0)
            q = query(io)
            @test unknown(q)

            # Short "file"
            truncate(io, 0)
            write(io, "S")
            seek(io, 0)
            q = query(io)
            @test unknown(q)

            truncate(io, 0)
            write(io, "JUNK and some more stuff")
            seek(io, 0)
            q = query(io)
            @test typeof(q) <: Stream{format"JUNK",typeof(io)}
            @test !(unknown(q))
            @test file_extension(q) == nothing
            # unseekable IO
            seek(io, 0)
            io.seekable = false
            @test !FileIO.seekable(io)
            q = query(io)
            @test typeof(q) <: Stream{format"JUNK",typeof(io)}
            io.seekable = true
            # too short to match
            io2 = IOBuffer()
            write(io2, "JU")
            seek(io2, 0)
            io2.seekable = false
            q = query(io2)
            @test unknown(q)

            # File with correct extension
            str = String(take!(io))
            fn = string(tempname(), ".jnk")
            open(fn, "w") do file
                write(file, str)
            end
            q = query(fn)
            @test typeof(q) <: File{format"JUNK"}
            @test file_extension(q) == ".jnk"
            # for good measure, test some constructors & other query calls
            @test query(q) == q
            @test File{format"JUNK"}(q) == q
            @test_throws ArgumentError("cannot change the format of $q to OTHER") File{format"OTHER"}(q)
            open(fn) do io
                @test query(io) isa Stream{format"JUNK", typeof(io)}
                @test query(io, q) isa Stream{format"JUNK", typeof(io)}
                @test Stream(q, io) isa Stream{format"JUNK", typeof(io)}
                @test Stream{format"JUNK"}(q, io) isa Stream{format"JUNK", typeof(io)}
                @test_throws ArgumentError Stream{format"OTHER"}(q, io)
            end

            rm(fn)

            # File with erroneous extension
            fn = string(tempname(), ".csv")
            open(fn, "w") do file
                write(file, str)
            end
            q = query(fn)
            @test typeof(q) <: File{format"JUNK"}
            @test file_extension(q) == ".csv"
            rm(fn)
            # erroneous extension with a file that has magic bytes
            fn = string(tempname(), ".othr")
            open(fn, "w") do file
                write(file, str)
            end
            q = query(fn)
            @test typeof(q) <: File{format"JUNK"}
            @test query(fn; checkfile=false) isa File{format"OTHER"}
            rm(fn)

            # Format with no magic bytes
            add_format(format"BAD", (), ".bad")
            fn = string(tempname(), ".bad")
            open(fn, "w") do file
                write(file, "Here's some data")
            end
            q = query(fn)
            @test typeof(q) <: File{format"BAD"}
            @test file_extension(q) == ".bad"
            rm(fn)

            q = query( "some_non_existant_file.bad")
            @test typeof(q) <: File{format"BAD"}

            # Unknown extension
            fn = string("tempname", ".wrd")
            open(fn, "w") do file
                write(file, "More data")
            end
            @test unknown(query(fn))
            rm(fn)

            add_format(format"DOUBLE_1", "test1", ".double")
            add_format(format"DOUBLE_2", "test2", ".double")

            fn = string(tempname(), ".double")
            open(fn, "w") do file
                write(file, "test1")
            end
            q = query(fn)
            @test typeof(q) <: File{format"DOUBLE_1"}
            rm(fn)

            # Busted detection function
            busted(io) = error("whoops")
            add_format(format"BUSTED", busted, ".bstd")
            fn = string(tempname(), ".bstd")
            open(fn, "w") do file
                write(file, "JUNK stuff")
            end
            @test (@test_logs (:error,r"There was an error in magic function .*busted") query(fn)) isa File{format"JUNK"}
            del_format(format"BUSTED")

            add_format(format"MAGIC", "this so magic", ".mmm")
            q = query( "some_non_existant_file.mmm")
            @test typeof(q) <: File{format"MAGIC"}

            add_format(format"DOUBLE_MAGIC", (UInt8[0x4d,0x4d,0x00,0x2a], UInt8[0x4d,0x4d,0x00]), ".dd2")

            fn = string(tempname(), ".dd2")
            open(fn, "w") do file
                write(file, UInt8[0x4d,0x4d,0x00,0x2a])
                write(file, randstring(19))
            end
            q = query(fn)
            @test typeof(q) <: File{format"DOUBLE_MAGIC"}
            io = open(q)
            skipmagic(io)
            @test position(io) == 4
            close(io)
            rm(fn)

            open(fn, "w") do file
                write(file, UInt8[0x4d,0x4d,0x00])
                write(file, randstring(19))
            end
            q = query(fn)
            @test typeof(q) <: File{format"DOUBLE_MAGIC"}
            io = open(q)
            @test file_extension(q) == ".dd2"
            skipmagic(io)
            @test position(io) == 3
            close(io)
            open(fn, "w") do file
                write(file, randstring(19)) # corrupt magic bytes
            end
            open(fn, "r") do file
                @test_throws ErrorException("tried to skip magic bytes of an IO that does not contain the magic bytes of the format. IO: $file") skipmagic(Stream{format"DOUBLE_MAGIC"}(file, fn))
            end
            open(fn, "r") do file
                @test_throws ErrorException("tried to skip magic bytes of an IO that does not contain the magic bytes of the format. IO: $file") skipmagic(file, format"DOUBLE_MAGIC")
            end
            rm(fn)
            lene0 = length(FileIO.ext2sym)
            lenm0 = length(FileIO.magic_list)
            del_format(format"DOUBLE_MAGIC")
            @test lene0 - 1 == length(FileIO.ext2sym)
            @test lenm0 - 2 == length(FileIO.magic_list)
        end

        del_format(format"JUNK")  # This triggers del_extension for multiple extensions


        @testset "multiple libs" begin
            lensave0 = length(FileIO.sym2saver)
            lenload0 = length(FileIO.sym2loader)
            OSKey = Sys.isapple() ? FileIO.OSX : Sys.iswindows() ? FileIO.Windows : Sys.islinux() ? FileIO.Linux : error("os not supported")
            add_format(
                format"MultiLib",
                UInt8[0x42,0x4d],
                ".mlb",
                [LoadTest1, FileIO.LOAD, OSKey],
                [LoadTest2]
            )
            @test lensave0 + 1 == length(FileIO.sym2saver)
            @test lenload0 + 1 == length(FileIO.sym2loader)
            @test length(FileIO.sym2loader[:MultiLib]) == 2
            @test length(FileIO.sym2saver[:MultiLib]) == 1
            fn = string(tempname(), ".mlb")
            save(fn, nothing)
            x = load(fn)
            open(query(fn), "r") do io
                skipmagic(io)
                a = read(io, Int)
                @test a == 42 #make sure that LoadTest2 is used for saving, even though its at position 2
            end
            @test isdefined(Main, :LoadTest1) # first module should load first but fail
            @test x == 42
            rm(fn)
        end

    finally
        # Restore the registry
        empty!(FileIO.ext2sym)
        empty!(FileIO.magic_list)
        empty!(FileIO.sym2info)

        merge!(FileIO.ext2sym, ext2sym)
        append!(FileIO.magic_list, magic_list)
        merge!(FileIO.sym2info, sym2info)
    end
end

@testset "detect $(format !== nothing ? format : "no") compression" for (ext, format) in [(nothing, nothing), (".gz", "GZIP"), (".bz2", "BZIP2"),
                                                            (".lz4", "LZ4"), (".xz", "XZ")]
    fname = joinpath(@__DIR__, "files", "dummy.txt")
    if ext !== nothing
        fname *= ext
    end
    open(fname) do io
        @test FileIO.detect_compressor(io, formats=[format]) == format # test with specific format only
    end
    open(fname) do io
        @test FileIO.detect_compressor(io, formats=[]) === nothing # test with no formats
    end
    open(fname) do io
        @test FileIO.detect_compressor(io) == format # test with all formats
    end
    open(fname) do io
        @test FileIO.detect_compressed(io) == (format !== nothing)
    end
end

let file_dir = joinpath(@__DIR__, "files"), file_path = Path(file_dir)
    @testset "Querying with $(typeof(fp))" for fp in (file_dir, file_path)
        @testset "bedGraph" begin
            q = query(joinpath(file_dir, "file.bedgraph"))
            @test typeof(q) <: File{format"bedGraph"}
            open(q) do io
                @test position(io) == 0
                skipmagic(io)
                @test position(io) == 0 # no skipping for functions
                # @test FileIO.detect_bedgraph(io) # MethodError: no method matching readline(::FileIO.Stream{FileIO.DataFormat{:bedGraph},IOStream}; chomp=false)
            end
            open(joinpath(file_dir, "file.bedgraph")) do io
                @test (FileIO.detect_bedgraph(io))
            end
        end
        @testset "STL detection" begin
            q = query(joinpath(file_dir, "ascii.stl"))
            @test typeof(q) <: File{format"STL_ASCII"}
            q = query(joinpath(file_dir, "binary_stl_from_solidworks.STL"))
            @test typeof(q) <: File{format"STL_BINARY"}
            # See Pull Request # 388
            q = query(joinpath(file_dir, "binary_stl_with_nonzero_attribute_byte_count.stl"))
            @test typeof(q) <: File{format"STL_BINARY"}
            open(q) do io
                @test position(io) == 0
                skipmagic(io)
                @test position(io) == 0 # no skipping for functions
            end
        end
        @testset "PLY detection" begin
            q = query(joinpath(file_dir, "ascii.ply"))
            @test typeof(q) <: File{format"PLY_ASCII"}
            q = query(joinpath(file_dir, "binary.ply"))
            @test typeof(q) <: File{format"PLY_BINARY"}

        end
        @testset "Multiple Magic bytes" begin
            q = query(joinpath(file_dir, "magic1.tiff"))
            @test typeof(q) <: File{format"TIFF"}
            q = query(joinpath(file_dir, "magic2.tiff"))
            @test typeof(q) <: File{format"TIFF"}
            open(q) do io
                @test position(io) == 0
                skipmagic(io)
                @test position(io) == 4
            end
        end
        @testset "AVI Detection" begin
            open(joinpath(file_dir, "bees.avi")) do s
                @test FileIO.detectavi(s)
            end
            open(joinpath(file_dir, "sin.wav")) do s
                @test !(FileIO.detectavi(s))
            end
            open(joinpath(file_dir, "magic1.tiff")) do s
                @test !(FileIO.detectavi(s))
            end
            q = query(joinpath(file_dir, "bees.avi"))
            @test typeof(q) <: File{format"AVI"}
        end
        @testset "MP4 detection" begin
            # archive.org is down
            # f = Downloads.download("https://archive.org/download/LadybirdOpeningWingsCCBYNatureClip/Ladybird%20opening%20wings%20CC-BY%20NatureClip.mp4")
            # q = query(f)
            # @test typeof(q) <: File{format"MP4"}
        end
        function try_download(url)
            try
                return Downloads.download(url)
            catch
                return nothing
            end
        end
        if Base.VERSION >= v"1.6" || !Sys.iswindows()
            # FIXME: Windows fails to download the files on Julia 1.0
            @testset "OGG detection" begin
                tmpfile = try_download("https://upload.wikimedia.org/wikipedia/commons/8/87/Annie_Oakley_shooting_glass_balls%2C_1894.ogv")
                if tmpfile == nothing
                    @test_skip "Skipped: network unavailable (download failed)"
                else
                    q = query(tmpfile)
                    @test typeof(q) <: File{format"OGG"}
                end
            end
            @testset "MATROSKA detection" begin
                tmpfile = try_download("https://upload.wikimedia.org/wikipedia/commons/1/13/Artist%E2%80%99s_impression_of_the_black_hole_inside_NGC_300_X-1_%28ESO_1004c%29.webm")
                if tmpfile == nothing
                    @test_skip "Skipped: network unavailable (download failed)"
                else
                    q = query(tmpfile)
                    @test typeof(q) <: File{format"MATROSKA"}
                end
            end
        end
        @testset "WAV detection" begin
            open(joinpath(file_dir, "sin.wav")) do s
                @test FileIO.detectwav(s)
            end
        end
        @testset "CSV detection" begin
            f = joinpath("files", "data.csv")
            q = query(f)
            @test typeof(q) <: File{format"CSV"}
        end
        @testset "RDA detection" begin
            q = query(joinpath(file_dir, "minimal_ascii.rda"))
            @test typeof(q) <: File{format"RData"}
            open(q) do io
                @test position(io) == 0
                @test FileIO.detect_rdata(io)
                # 6 for /r/n  and 5 for /n
                @test (position(io) in (5, 6))
            end
            # A GZipped file
            q = query(joinpath(file_dir, "iris.rda"))
            @test typeof(q) <: File{format"RData"}
        end
        @testset "RDS detection" begin
            q = query(joinpath(file_dir, "minimal_ascii.rds"))
            @test typeof(q) <: File{format"RDataSingle"}
            open(q) do io
                @test position(io) == 0
                @test FileIO.detect_rdata_single(io)
                # need to seek to beginning of file where data structure starts
                @test position(io)  == 0
            end
        end
        @testset "MIDI detection" begin
            q = query(joinpath(file_dir, "doxy.mid"))
            @test typeof(q) <: File{format"MIDI"}
            q = query(joinpath(file_dir, "doxy.midi"))
            @test typeof(q) <: File{format"MIDI"}
            q = query(joinpath(file_dir, "doxy2.MID"))
            @test typeof(q) <: File{format"MIDI"}
            @test magic(format"MIDI") == b"MThd"
            open(q) do io
                @test position(io) == 0
                skipmagic(io)
                @test position(io) == 4
            end
        end
        @testset "OpenEXR detection" begin
            q = query(joinpath(file_dir, "rand.exr"))
            @test typeof(q) <: File{format"EXR"}
            @test magic(format"EXR") == UInt8[0x76, 0x2F, 0x31, 0x01]
            open(q) do io
                @test position(io) == 0
                skipmagic(io)
                @test position(io) == 4
            end
        end
        @testset "Sixel detection" begin
            q = query(joinpath(file_dir, "rand.six"))
            @test typeof(q) <: File{format"SIXEL"}
            q = query(joinpath(file_dir, "rand.sixel"))
            @test typeof(q) <: File{format"SIXEL"}
            open(q) do io
                @test position(io) == 0
                skipmagic(io)
                @test position(io) == 3
            end
        end
        @testset "AVSfld detection" begin
            q = query(joinpath(file_dir, "avs-ascii.fld"))
            @test typeof(q) <: File{format"AVSfld"}
        end

        @testset "MuData detection" begin
            q = query(joinpath(file_dir, "file1.h5mu"))
            @test typeof(q) <: File{format"h5mu"}
            q = query(joinpath(file_dir, "h5mu.test"))
            @test typeof(q) <: File{format"h5mu"}
        end

        @testset "AnnData detection" begin
            q = query(joinpath(file_dir, "file1.h5ad"))
            @test typeof(q) <: File{format"h5ad"}
            q = query(joinpath(file_dir, "file2.h5ad"))
            @test typeof(q) <: File{format"h5ad"}
            q = query(joinpath(file_dir, "h5ad.h5"))
            @test typeof(q) <: File{format"HDF5"}
        end

        @testset "HDF5 detection" begin
            q = query(joinpath(file_dir, "file1.h5"))
            @test typeof(q) <: File{format"HDF5"}
            q = query(joinpath(file_dir, "file2.h5"))
            @test typeof(q) <: File{format"HDF5"}
        end

        @testset "Bibliography detection" begin
            q = query(joinpath(file_dir, "file.bib"))
            @test typeof(q) <: File{format"BIB"}
        end

        @testset "DICOM detection" begin
            q = query(joinpath(file_dir, "CT_JPEG70.dcm"))
            @test typeof(q) <: File{format"DCM"}
        end
    end

    @testset "Query from IOBuffer" begin
        streamformat(::Stream{T, U}) where {T, U} = T
        for name ∈ ["magic1.tiff", "magic2.tiff"]
            pth = joinpath(file_dir, "magic2.tiff")
            open(pth) do io
                buf=IOBuffer(read(io))
                @test streamformat(query(buf)) == DataFormat{:TIFF}
            end
        end
    end

    @testset "issue #338" begin
        open("test.png", "w") do io
            write(io, UInt8('R'))
        end
        q = query("test.png")
        @test FileIO.formatname(q) == :PNG
        q = query("test.png"; checkfile=false)
        @test FileIO.formatname(q) == :PNG
        rm("test.png")
    end

    @testset "issue #345" begin
        iris = joinpath("files", "iris.rda")

        q = query(iris)
        @test typeof(q) <: File{format"RData"}

        io = open(iris)
        q = query(io)
        @test typeof(q) <: Stream{format"RData"}
        @test FileIO.detect_rdata(io)

        # issue #345: it errors here
        io = CodecZlib.GzipDecompressorStream(open(iris))
        q = query(io)
        @test FileIO.unknown(q) # FIXME: should be RData
        @test FileIO.detect_rdata(io)
    end

    @testset "Gadget2" begin
        q = query(joinpath(file_dir, "gassphere_littleendian.gadget2"))
        @test typeof(q) <: File{format"Gadget2"}
    end
end

using FileIO
using ColorTypes
using ColorTypes.FixedPointNumbers
using HTTP
using Pkg
using Test

@testset "Integration" begin
    if haskey(ENV, "CI") && Base.VERSION >= v"1.3"  # ImageIO can't be loaded on Julia < 1.3, so putting it as test dep is problematic
        Pkg.add("ImageIO")
        img = rand(RGB{N0f8}, 50, 50)
        io = IOBuffer()
        save(Stream{format"PNG"}(io), img)
        buf = take!(io)
        io2 = IOBuffer(buf)
        img2 = load(io2)
        @test img2 == img

        uri = HTTP.URI("https://raw.githubusercontent.com/JuliaImages/TestImages.jl/images/images/autumn_leaves.png")
        @test isa(load(uri), Matrix)
    end
end

# This file contains the code that allows things to be added to the registry

const ext2sym    = Dict{String, Union{Symbol,Vector{Symbol}}}()
const magic_list = Vector{Pair{Vector{UInt8},Symbol}}()     # sorted, see magic_cmp below
const sym2info   = Dict{Symbol,Tuple{Any,Any}}()   # Symbol=>(magic, extension)
const magic_func = Vector{Pair{Function,Symbol}}() # for formats with complex magic detection
const empty_magic = UInt8[]

## OS:
@enum OS Unix Windows OSX Linux

applies_to_os(oslist) = isempty(oslist) || any(applies_to_os, oslist)
function applies_to_os(os::OS)
    os == Unix && return Sys.isunix()
    os == Windows && return Sys.iswindows()
    os == OSX && return Sys.isapple()
    os == Linux && return Sys.islinux()
    return false
end

## Magic bytes:

# magic_cmp results in magic_list being sorted in order of increasing
# length(magic), then (among sequences with the same length) in
# lexographic order. This ordering has the advantage that you can
# incrementally read bytes from the stream without worrying that
# you'll encounter an EOF yet still have potential matches later in
# the list.
function magic_cmp(a::Vector{UInt8}, b::Vector{UInt8})
    la, lb = length(a), length(b)
    la < lb && return true
    la > lb && return false
    for (ia, ib) in zip(a, b)
        ia < ib && return true
        ia > ib && return false
    end
    return false
end
magic_cmp(p::Pair, m::Vector{UInt8}) = magic_cmp(p.first, m)
magic_cmp(m::Vector{UInt8}, p::Pair) = magic_cmp(m, p.first)

canonicalize_magic(@nospecialize(m::Tuple{Vararg{UInt8}})) = UInt8[m...]
canonicalize_magic(m::AbstractVector{UInt8}) = convert(Vector{UInt8}, m)
canonicalize_magic(m::String) = canonicalize_magic(codeunits(m))


## Load/Save

@enum IOSupport LOAD SAVE

function split_predicates(list)
    os = OS[]
    ls = IOSupport[]
    for item in list
        if isa(item, OS)
            push!(os, item)
        else
            push!(ls, item)
        end
    end
    return os, ls
end


function add_loadsave(format, predicates)
    library = popfirst!(predicates)
    os, loadsave = split_predicates(predicates)
    if applies_to_os(os)
        if isempty(loadsave) || (LOAD in loadsave)
            add_loader(format, library)
        end
        if isempty(loadsave) || (SAVE in loadsave)
            add_saver(format, library)
        end
    end
end

## Add Format:

function add_format(fmt, magic, extension, load_save_libraries...)
    for library in load_save_libraries
        add_loadsave(fmt, library)
    end
    # Add the format after we've validated the packages (to prevent a partially-registered format)
    add_format(fmt, magic, extension)
    fmt
end

"""
    add_format(fmt, magic, extension)

registers a new [`DataFormat`](@ref).

For example:
```julia
add_format(format"TIFF", (UInt8[0x4d,0x4d,0x00,0x2b], UInt8[0x49,0x49,0x2a,0x00]), [".tiff", ".tif"])
add_format(format"PNG", [0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a], ".png")
add_format(format"NRRD", "NRRD", [".nrrd",".nhdr"])
```

Note that extensions, magic numbers, and format-identifiers are case-sensitive.

You can also specify particular packages that support the format with `add_format(fmt, magic, extension, pkgspecifiers...)`,
where example `pkgspecifiers` are:
```julia
add_format(fmt, magic, extension, [:PkgA=>UUID(...)])                     # only PkgA supports the format (load & save)
add_format(fmt, magic, extension, [:PkgA=>uuidA], [:PkgB=>uuidB])         # try PkgA first, but if it fails try PkgB
add_format(fmt, magic, extension, [:PkgA=>uuidA, LOAD], [:PkgB=>uuidB])   # try PkgA first for `load`, otherwise use PkgB
add_format(fmt, magic, extension, [:PkgA=>uuidA, OSX], [:PkgB=>uuidB])    # use PkgA on OSX, and PkgB otherwise
```
The `uuid`s are all of type `UUID` and can be obtained from the package's `Project.toml` file.

You can combine `LOAD`, `SAVE`, `OSX`, `Unix`, `Windows` and `Linux` arbitrarily to narrow `pkgspecifiers`.
"""
add_format(@nospecialize(fmt::Type), args...) = add_format(formatname(fmt)::Symbol, args...)
add_format(sym::Symbol, magic::Union{Tuple,AbstractVector{UInt8},String}, extension) =
    add_format(sym, canonicalize_magic(magic), extension)
function add_format(sym::Symbol,
                    @nospecialize(magics::Tuple{Vector{UInt8},Vararg{Vector{UInt8}}}), extension)
    add_format(sym, [magics...], extension)
end

function add_format(sym::Symbol, magic::Vector{UInt8}, extension)
    haskey(sym2info, sym) && error("format ", sym, " is already registered")
    rng = searchsorted(magic_list, magic, lt=magic_cmp)
    if !isempty(magic) && !isempty(rng)
        error("magic bytes ", magic, " are already registered")
    end
    insert!(magic_list, first(rng), magic=>sym)
    sym2info[sym] = (magic, extension)
    add_extension(extension, sym)
    nothing
end

# for multiple magic bytes
function add_format(sym::Symbol, magics::Vector{Vector{UInt8}}, extension)
    haskey(sym2info, sym) && error("format ", sym, " is already registered")
    for magic in magics
        rng = searchsorted(magic_list, magic, lt=magic_cmp)
        if !isempty(magic) && !isempty(rng)
            error("magic bytes ", magic, " are already registered")
        end
        insert!(magic_list, first(rng), magic=>sym)
    end
    sym2info[sym] = (sort(magics; lt=magic_cmp), extension)
    add_extension(extension, sym)
    nothing
end

# For when "magic" is supplied as a function (see the HDF5 example in
# registry.jl)
function add_format(sym::Symbol, @nospecialize(magic::Function), extension)
    haskey(sym2info, sym) && error("format ", sym, " is already registered")
    push!(magic_func, Pair(magic,sym))  # magic=>sym in 0.4
    sym2info[sym] = (magic, extension)
    add_extension(extension, sym)
    nothing
end

"""
    del_format(fmt::DataFormat)

deletes `fmt` from the format registry.
"""
del_format(@nospecialize(fmt::Type)) = del_format(formatname(fmt)::Symbol)
function del_format(sym::Symbol)
    magic, extension = sym2info[sym]
    del_magic(magic, sym)
    delete!(sym2info, sym)
    del_extension(extension)
    nothing
end

# # Deletes multiple magic bytes
# del_magic(magic::Tuple, sym) = for m in magic
#     del_magic(m, sym)
# end
# Deletes single magic bytes
del_magic(@nospecialize(magic), sym::Symbol) = del_magic(canonicalize_magic(magic), sym)
function del_magic(magic::Vector{UInt8}, sym::Symbol)
    rng = searchsorted(magic_list, magic, lt=magic_cmp)
    if length(magic) == 0
        fullrng = rng
        found = false
        for idx in fullrng
            if last(magic_list[idx]) == sym
                rng = idx:idx
                found = true
                break
            end
        end
        found || error("format ", sym, " not found")
    end
    @assert length(rng) == 1
    deleteat!(magic_list, first(rng))
    nothing
end
del_magic(magics::Vector{Vector{UInt8}}, sym::Symbol) = foreach(magics) do magic
    del_magic(magic, sym)
end

function del_magic(@nospecialize(magic::Function), sym::Symbol)
    deleteat!(magic_func, something(findfirst(isequal(Pair{Function,Symbol}(magic,sym)), magic_func), 0))
    nothing
end

## File Extensions:

function add_extension(ext::String, sym::Symbol)
    if haskey(ext2sym, ext)
        v = ext2sym[ext]
        if isa(v, Symbol)
            ext2sym[ext] = Symbol[v, sym]
        else
            push!(ext2sym[ext], sym)
        end
        return
    end
    ext2sym[ext] = sym
end
function add_extension(ext::Union{Array,Tuple}, sym)
    for e in ext
        add_extension(e, sym)
    end
end

del_extension(ext::String) = delete!(ext2sym, ext)
function del_extension(ext::Union{Array,Tuple})
    for e in ext
        del_extension(e)
    end
end

# Deprecations added in 1.5.0, March 2021

function File(fmt::Type{DataFormat{sym}}, filename) where {sym}
    Base.depwarn("`File(format\"$sym\", filename)` is deprecated, please use `File{format\"$sym\"}(filename)` instead.", :File)
    return File{fmt}(filename)
end
function Stream(fmt::Type{DataFormat{sym}}, args...) where {sym}
    Base.depwarn("`Stream(format\"$sym\", filename)` is deprecated, please use `Stream{format\"$sym\"}(filename)` instead.", :Stream)
    return Stream{fmt}(args...)
end

# These aren't used here, but old versions of ImageIO expect them

function _findmod(f::Symbol)
    Base.depwarn("_findmod is deprecated and will be removed. Use `Base.require(::Base.PkgId)` instead.", :_findmod)
    for (u,v) in Base.loaded_modules
        (Symbol(v) == f) && return u
    end
    nothing
end
function topimport(modname)
    Base.depwarn("topimport is deprecated and will be removed. Use `Base.require(::Base.PkgId)` instead.", :topimport)
    @eval Base.__toplevel__  import $modname
    u = _findmod(modname)
    @eval $modname = Base.loaded_modules[$u]
end

# Legacy add_loader/add_saver
for add_ in (:add_loader, :add_saver)
    @eval begin
        function $add_(fmt, pkg)
            # TODO: delete this method in FileIO v2
            sym = isa(fmt, Symbol) ? fmt : formatname(fmt)::Symbol
            Base.depwarn(string($add_) * "(fmt, pkg::$(typeof(pkg))) is deprecated, supply `pkg` as a Module or `name=>uuid`", Symbol($add_))
            pkg === :MimeWriter && return $add_(sym, MimeWriter)
            # Try to look it up in the caller's environment
            pkgname = string(pkg)
            id = Base.identify_package(pkgname)
            if id === nothing
                # See if it's in Main
                pkgsym = Symbol(pkg)
                if isdefined(Main, pkgsym)
                    id = getfield(Main, pkgsym)
                    if !isa(id, Module)
                        id = nothing
                    end
                end
                if id === nothing
                    # Look it up in the registries. The tricky part here is supporting different Julia versions
                    ctx = Pkg.API.Context()
                    uuids = UUID[]
                    @static if Base.VERSION >= v"1.2"
                        if hasfield(typeof(ctx), :registries)
                            for reg in ctx.registries
                                append!(uuids, Pkg.Registry.uuids_from_name(reg, pkgname))
                            end
                        else
                            ctx = Pkg.API.Context!(ctx)
                            if isdefined(Pkg.Types, :find_registered!) && hasmethod(Pkg.Types.find_registered!, (typeof(ctx.env), Vector{String}))
                                Pkg.Types.find_registered!(ctx.env, [pkgname])
                            elseif isdefined(Pkg.Types, :find_registered!) && hasmethod(Pkg.Types.find_registered!, (typeof(ctx), Vector{String}))
                                Pkg.Types.find_registered!(ctx, [pkgname])
                            end
                            append!(uuids, get(ctx.env.uuids, pkgname, UUID[]))
                        end
                    else
                        Pkg.Types.find_registered!(ctx.env)
                        append!(uuids, get(ctx.env.uuids, pkgname, UUID[]))
                    end
                    isempty(uuids) && throw(ArgumentError("no UUID found for $pkg"))
                    length(uuids) == 1 || throw(ArgumentError("multiple UUIDs found for $pkg"))
                    id = PkgId(uuids[1], pkgname)
                end
            end
            $add_(sym, id)
        end
    end
end

const ActionSource = Union{PkgId,Module}
const sym2loader = Dict{Symbol,Vector{ActionSource}}()
const sym2saver  = Dict{Symbol,Vector{ActionSource}}()

for (applicable_, add_, dict_) in (
        (:applicable_loaders, :add_loader, :sym2loader),
        (:applicable_savers,  :add_saver,  :sym2saver))
    @eval begin
        function $applicable_(sym::Symbol)
            ret = get($dict_, sym, nothing)
            ret === nothing && error(string("No ", $applicable_, " found for ", sym))
            return ret
        end
        $add_(@nospecialize(fmt::Type), id::Union{ActionSource,Pair}) = $add_(formatname(fmt)::Symbol, id)
        function $add_(sym::Symbol, id::ActionSource)
            list = get!(Vector{ActionSource}, $dict_, sym)
            push!(list, id)
        end
        $add_(sym::Symbol, pkg::Pair{<:Union{String,Symbol}, UUID}) = $add_(sym, Base.PkgId(pkg.second, String(pkg.first)))
    end
end


"""
    add_loader(fmt, :Package=>uuid)
    add_loader(fmt, [:Package=>uuid, specifiers...])

Declare that format `fmt` can be loaded with package `:Package`.
Specifiers include `OSX`, `Unix`, `Windows` and `Linux` to restrict usage to particular operating systems.

See also [`add_format`](@ref) which can combine package support with the format declaration.
"""
add_loader

"""
    add_saver(fmt, :Package=>uuid)
    add_saver(fmt, [:Package=>uuid, specifiers...])

Declare that format `fmt` can be saved with package `:Package`.
Specifiers include `OSX`, `Unix`, `Windows` and `Linux` to restrict usage to particular operating systems.

See also [`add_format`](@ref) which can combine package support with the format declaration.
"""
add_saver

"""
- `load(filename)` loads the contents of a formatted file, trying to infer
  the format from `filename` and/or magic bytes in the file (see [`query`](@ref)).
- `load(strm)` loads from an `IOStream` or similar object. In this case,
  there is no filename extension, so we rely on the magic bytes for format
  identification.
- `load(File{format"PNG"}(filename))` specifies the format directly, and bypasses the format [`query`](@ref).
- `load(Stream{format"PNG"}(io))` specifies the format directly, and bypasses the format [`query`](@ref).
- `load(f; options...)` passes keyword arguments on to the loader.
"""
load

"""
Some packages may implement a streaming API, where the contents of the file can
be read in chunks and processed, rather than all at once. Reading from these
higher-level streams should return a formatted object, like an image or chunk of
video or audio.

- `loadstreaming(filename)` loads the contents of a formatted file, trying to infer
  the format from `filename` and/or magic bytes in the file. It returns a streaming
  type that can be read from in chunks, rather than loading the whole contents all
  at once.
- `loadstreaming(strm)` loads the stream from an `IOStream` or similar object.
  In this case, there is no filename extension, so we rely on the magic bytes
  for format identification.
- `loadstreaming(File{format"WAV"}(filename))` specifies the format directly, and
  bypasses the format [`query`](@ref).
- `loadstreaming(Stream{format"WAV"}(io))` specifies the format directly, and
  bypasses the format [`query`](@ref).
- `loadstreaming(f; options...)` passes keyword arguments on to the loader.
"""
loadstreaming

"""
- `save(filename, data...)` saves the contents of a formatted file,
  trying to infer the format from `filename`.
- `save(Stream{format"PNG"}(io), data...)` specifies the format directly, and
  bypasses the format [`query`](@ref).
- `save(File{format"PNG"}(filename), data...)` specifies the format directly, and
  bypasses the format [`query`](@ref).
- `save(f, data...; options...)` passes keyword arguments on to the saver.
"""
save

"""
Some packages may implement a streaming API, where the contents of the file can
be written in chunks, rather than all at once. These higher-level streams should
accept formatted objects, like an image or chunk of video or audio.

- `savestreaming(filename, data...)` saves the contents of a formatted file,
  trying to infer the format from `filename`.
- `savestreaming(File{format"WAV"}(filename))` specifies the format directly, and
  bypasses the format [`query`](@ref).
- `savestreaming(Stream{format"WAV"}(io))` specifies the format directly, and
  bypasses the format [`query`](@ref).
- `savestreaming(f, data...; options...)` passes keyword arguments on to the saver.
"""
savestreaming

# if a bare filename or IO stream are given, query for the format and dispatch
# to the formatted handlers below
for fn in (:load, :loadstreaming, :metadata)
    fnq = QuoteNode(fn)
    @eval function $fn(file, args...; options...)
        checkpath_load(file)
        sym = querysym(file)
        libraries = applicable_loaders(sym)
        return action($fnq, libraries, sym, file, args...; options...)
    end
    # Version that bypasses format-inference
    @eval function $fn(@nospecialize(file::Formatted), args...; options...)
        checkpath_load(filename(file))
        sym = formatname(file)::Symbol
        libraries = applicable_loaders(sym)
        return action($fnq, libraries, file, args...; options...)
    end
end
for fn in (:save, :savestreaming)
    fnq = QuoteNode(fn)
    @eval function $fn(file, args...; options...)
        checkpath_save(file)
        sym = querysym(file; checkfile=false)
        libraries = applicable_savers(sym)
        return action($fnq, libraries, sym, file, args...; options...)
    end
    @eval function $fn(@nospecialize(file::Formatted), args...; options...)
        checkpath_save(filename(file))
        sym = formatname(file)::Symbol
        libraries = applicable_savers(sym)
        return action($fnq, libraries, file, args...; options...)
    end
    @eval function $fn(@nospecialize(fmt::Type), file, args...; options...)
        checkpath_save(file)
        sym = formatname(fmt)::Symbol
        libraries = applicable_savers(sym)
        return action($fnq, libraries, sym, file, args...; options...)
    end
end

# return a save function, so you can do `thing_to_save |> save("filename.ext")`
function save(file; options...)
    sym = querysym(file; checkfile=false)
    libraries = applicable_savers(sym)
    return data -> action(:save, libraries, sym, file, data; options...)
end

# do-syntax for streaming IO
for fn in (:loadstreaming, :savestreaming)
    @eval function $fn(@nospecialize(f::Function), @nospecialize(args...); @nospecialize(kwargs...))
        str = $fn(args...; kwargs...)
        try
            f(str)
        finally
            close(str)
        end
    end
end

function checkpath_load(file)
    file === nothing && return nothing   # likely stream io
    isa(file, IO) && return nothing
    _isurl(file) || isfile(file) || throw(ArgumentError("No file exists at given path: $file"))
    return nothing
end
function checkpath_save(file)
    file === nothing && return nothing
    isa(file, IO) && return nothing
    isdir(file) && throw(ArgumentError("Given file path is a directory: $file"))
    dn = dirname(file)
    !isdir(dn) && mkpath(dn)
    return nothing
end

# TODO: we may use URI when cases become complex
_isurl(path::AbstractString) = startswith(path, "http://") || startswith(path, "https://")
_isurl(path) = false

action(call::Symbol, libraries::Vector{ActionSource}, sym::Symbol, io::IO, args...; options...) =
    action(call, libraries, Stream{DataFormat{sym}}(io), args...; options...)
action(call::Symbol, libraries::Vector{ActionSource}, sym::Symbol, file, args...; options...) =
    action(call, libraries, File{DataFormat{sym}}(file), args...; options...)

# To test for broken packages which extend FileIO functions
const fileiofuncs = Dict{Symbol,Function}(:load => load,
                                          :loadstreaming => loadstreaming,
                                          :metadata => metadata,
                                          :save => save,
                                          :savestreaming => savestreaming)

const require_lock = ReentrantLock()
function action(call::Symbol, libraries::Vector{ActionSource}, @nospecialize(file::Formatted), args...; options...)
    issave = call ∈ (:save, :savestreaming)
    failures = Tuple{Any,ActionSource,Vector}[]
    pkgfuncname = Symbol("fileio_", call)
    local mod
    for library in libraries
        try
            mod = isa(library, Module) ? library : lock(() -> Base.require(library), require_lock)
            f = if isdefined(mod, pkgfuncname)
                getfield(mod, pkgfuncname)
            elseif isdefined(mod, call)
                getfield(mod, call)
            else
                throw(SpecError(mod, call))
            end
            if f === fileiofuncs[call]
                argtyps = map(Core.Typeof, args)
                m = which(f, (typeof(file), argtyps...))
                if m == which(f, (Formatted, argtyps...))  # is it equal to a fallback?
                    throw(SpecError(mod, call))            # prevent a StackOverflowError
                end
                @warn "$mod incorrectly extends FileIO functions (see FileIO documentation)"
            end
            return Base.invokelatest(f, file, args...; options...)
        catch e
            if isa(e, SpecError)
                str = "neither $call nor $pkgfuncname is defined"
                e = issave ? WriterError(string(mod), str, e) : LoaderError(string(mod), str, e)
            end
            push!(failures, (e, library, catch_backtrace()))
        end
    end
    handle_exceptions(failures, "$call $(repr(file))")
end

using FileIO
using FilePathsBase
using Test
using UUIDs
using CodecZlib

Threads.nthreads() <= 1 && @info "Threads.nthreads() = $(Threads.nthreads()), multithread tests will be disabled"

# Both FileIO and FilePathsBase export filename, but we only want the FileIO definition.
using FileIO: filename

struct MimeSaveTestType
end

@testset "FileIO" begin
    # This threaded test should be put before `CSVFiles` is loaded
    if VERSION >= v"1.3"
        # FIXME: threaded file io is still somehow broken in old Julia versions
        include("threaded_loading.jl")
    end

    include("query.jl")
    include("loadsave.jl")
    include("error_handling.jl")
    include("test_mimesave.jl")
    include("integration.jl")
end

using Aqua
Aqua.test_all(FileIO)

@testset "Threaded loading" begin
    if Threads.nthreads() > 1
        pkgid = Base.PkgId(FileIO.idCSVFiles.second, "CSVFiles")
        @assert !Base.root_module_exists(pkgid) "threaded loaidng test requires CSVFiles not loaded"
        # When threaded, loading a new backend should be locked
        # https://github.com/JuliaIO/FileIO.jl/issues/336
        files = map(["data.csv", "file.csv"]) do filename
            joinpath(@__DIR__, "files", filename)
        end
        @test_nowarn Threads.@threads for file in files
            load(file)
        end
    end
end

# This file updates `docs/src/registry.md` (it does not build documentation in general)
module RegistryMD

using FileIO: FileIO, LOAD, SAVE, OSX, OS, DataFormat, @format_str, MimeWriter
using UUIDs
using Pkg

const ctx = Pkg.Types.Context()
try
    ctx.registries
catch
    error("this file must be run on Julia 1.6 or higher")
end

function pkg_url(uuid)
    for reg in ctx.registries
        entry = get(reg.pkgs, uuid, nothing)
        entry === nothing && continue
        info = Pkg.Registry.init_package_info!(entry)
        base, ext = splitext(info.repo)
        return ext == ".git" ? base : info.repo
    end
end
library2string(x::Pair{<:Any,UUID}) = "[$(x.first)]($(pkg_url(x.second)))"
library2string(x::Module) = string(nameof(x))

extension2string(x) = join(map(string, x), ", ")
extension2string(x::AbstractString) = x

os2string(x::Vector) = isempty(x) ? "all platforms " : join(map(os2string, x), ", ")
os2string(os::Type{O}) where {O <: OS} = "$(O.name.name)"

magic2string(x::Function) = "has detection function"
magic2string(x::Tuple) = isempty(x) ? "only extension" : string(x)
magic2string(x::AbstractString) = '"' * escape_string(x, ['_']) * '"'
magic2string(x) = string(x)
function loadsave2string(load_save_libraries)
    io = IOBuffer()
    loader_str, saver_str = " ", " "
    for (i, predicates) in enumerate(load_save_libraries)
        library = popfirst!(predicates)

        os, loadsave = FileIO.split_predicates(predicates)
        if isempty(loadsave)
            print(io, "loads and saves on all platforms with ", library2string(library), " ")
        elseif (LOAD in loadsave)
            print(io, "loads with ", library2string(library), " on ", os2string(os), " ")
        elseif (SAVE in loadsave)
            print(io, "saves with ", library2string(library), " on ", os2string(os), " ")
        end
        i < length(load_save_libraries) && print(io, '\n')
    end
    split(String(take!(io)), '\n')
end

fs = open(joinpath(pkgdir(FileIO), "docs", "src", "registry.md"), "w")

    println(fs, "# Registry table")
    println(fs)
    println(fs, "The following formats are registered with FileIO:")
    println(fs)

    function add_format(::Type{DataFormat{Sym}}, magic, extension, io_libs...) where Sym
        liblinks = loadsave2string(io_libs)
        for (i, lib) in enumerate(liblinks)
            if i == 1
                println(fs, "| $(Sym) | $(extension2string(extension)) | $lib | $(magic2string(magic)) |")
            else
                println(fs, "| | | $lib | |")
            end
        end
    end


    function add_format(fmt::Type{DataFormat{sym}}, magic::Union{Tuple,AbstractVector,String}, extension) where sym
        println(sym)
    end

    # for multiple magic bytes
    function add_format(sym::Symbol, magics::Vector{Vector{UInt8}}, extension)
        println(sym)
    end

    # For when "magic" is supplied as a function (see the HDF5 example in
    # registry.jl)
    function add_format(fmt::Type{DataFormat{sym}}, magic, extension) where sym
        println(sym)
    end


    println(fs, """
    | Format Name | extensions | IO library | detection or magic number |
    | ----------- | ---------- | ---------- | ------------------------- |""")
    include(joinpath(pkgdir(FileIO), "src", "registry.jl"))

close(fs)

end  # module RegistryMD

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    for f in (detect_rdata, detect_rdata_single, detectwav, detect_bedgraph,
              detecttiff, detect_noometiff, detect_ometiff, detectavi,
              detecthdf5, detect_stlascii, detect_stlbinary, detect_gadget2)
        @assert precompile(f, (IOStream,))
    end

    for F in (String, IOStream, Formatted)
        @assert precompile(query, (F,))
        @assert precompile(load, (F,))
        @assert precompile(save, (F,Nothing,))
        @assert precompile(loadstreaming, (F,))
        @assert precompile(savestreaming, (F,))
    end
    @assert precompile(action, (Symbol,Vector{Union{PkgId, Module}},Symbol,String))
    @assert precompile(action, (Symbol,Vector{Union{PkgId, Module}},Symbol,IOStream))
    @assert precompile(action, (Symbol,Vector{Union{PkgId, Module}},Formatted))
    @assert precompile(loadstreaming, (Function, Any))
    @assert precompile(savestreaming, (Function, Any))
    @assert precompile(skipmagic, (IOStream,Vector{Vector{UInt8}},))
end

using Documenter
using FileIO

include("populate_registry.jl")

makedocs(
    sitename = "FileIO",
    format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true"),
    modules = [FileIO],
    pages = [
        "Home" => "index.md",
        "registry.md",
        "registering.md",
        "implementing.md",
        "world_age_issue.md",
        "reference.md",
    ],
    checkdocs = :exports,
)

deploydocs(
    repo = "github.com/JuliaIO/FileIO.jl.git",
    push_preview = true,
)

module FileIO

export DataFormat,
       File,
       Formatted,
       Stream,
       @format_str,
       add_format,
       del_format,
       add_loader,
       add_saver,
       filename,
       file_extension,
       load,
       loadstreaming,
       magic,
       query,
       save,
       savestreaming,
       skipmagic,
       stream,
       unknown,
       metadata

import Base.showerror
using Base: RefValue, PkgId
using Pkg
using UUIDs
using Requires

include("types.jl")
include("registry_setup.jl")
include("query.jl")
include("error_handling.jl")
include("loadsave.jl")
include("mimesave.jl")
include("registry.jl")


"""
`FileIO` API (brief summary, see individual functions for more detail):

- `format"PNG"`: specifies a particular defined format
- [`File{fmt}`](@ref) and [`Stream{fmt}`](@ref): types of objects that declare that a resource has a particular format `fmt`

- [`load([filename|stream])`](@ref): read data in formatted file, inferring the format
- `load(File{format"PNG"}(filename))`: specify the format manually
- [`loadstreaming([filename|stream])`](@ref): similar to `load`, except that it returns an object that can be read from
- [`save(filename, data...)`](@ref) for similar operations involving saving data
- [`savestreaming([filename|stream])`](@ref): similar to `save`, except that it returns an object that can be written to

- `io = open(f::File, args...)` opens a file
- [`io = stream(s::Stream)`](@ref stream) returns the IOStream from the query object `s`

- [`query([filename|stream])`](@ref): attempt to infer the format of `filename`
- [`unknown(q)`](@ref) returns true if a query can't be resolved
- [`skipmagic(io, fmt)`](@ref) sets the position of `io` to just after the magic bytes
- [`magic(fmt)`](@ref) returns the magic bytes for format `fmt`
- [`info(fmt)`](@ref) returns `(magic, extensions)` for format `fmt`

- [`add_format(fmt, magic, extension, libraries...)`](@ref): register a new format
- [`add_loader(fmt, :Package)`](@ref): indicate that `Package` supports loading files of type `fmt`
- [`add_saver(fmt, :Package)`](@ref): indicate that `Package` supports saving files of type `fmt`
"""
FileIO

@static if !isdefined(Base, :get_extension)
function __init__()
    @require HTTP="cd3eb016-35fb-5094-929b-558a96fad6f3" begin
        include("../ext/HTTPExt.jl")
    end
end
end # @static

if VERSION >= v"1.4.2" # https://github.com/JuliaLang/julia/pull/35378
    include("precompile.jl")
    _precompile_()
end

include("deprecated.jl")

end

# "Public" types that represent the file formats. These are used
# to communicate results externally, but are generally avoided for
# internal operations because they trigger excessive specialization
# and inference failures.

## DataFormat:
"""
    DataFormat{sym}()

Indicates a known binary or text format of kind `sym`, where `sym`
is always a symbol. For example, a .csv file might have `DataFormat{:CSV}()`.

An easy way to write `DataFormat{:CSV}` is `format"CSV"`.
"""
struct DataFormat{sym} end

macro format_str(s)
    :(DataFormat{$(Expr(:quote, Symbol(s)))})
end

formatname(::Type{DataFormat{sym}}) where sym = sym


abstract type Formatted{F<:DataFormat} end  # A specific file or stream

formatname(::Formatted{F}) where F<:DataFormat = formatname(F)

## File:

"""
    File{fmt}(filename)

Indicates that `filename` is a file of known [`DataFormat`](@ref) `fmt`.
For example, `File{format"PNG"}(filename)` would indicate a PNG file.

!!! compat
    `File{fmt}(filename)` requires FileIO 1.6 or higher. The deprecated syntax `File(fmt, filename)` works
    on all FileIO 1.x releases.
"""
struct File{F<:DataFormat, Name} <: Formatted{F}
    filename::Name
end
File{F}(file::File{F}) where F<:DataFormat = file
File{DataFormat{sym}}(@nospecialize(file::Formatted)) where sym = throw(ArgumentError("cannot change the format of $file to $sym"))
File{F}(file::AbstractString) where F<:DataFormat = File{F,String}(String(file)) # canonicalize to limit type-diversity
File{F}(file) where F<:DataFormat = File{F,typeof(file)}(file)

# The docs are separated from the definition because of https://github.com/JuliaLang/julia/issues/34122
filename(@nospecialize(f::File)) = f.filename
"""
    filename(file)

Returns the filename associated with [`File`](@ref) `file`.
"""
filename(::File)

file_extension(@nospecialize(f::File)) = splitext(filename(f))[2]
"""
    file_extension(file)

Returns the file extension associated with [`File`](@ref) `file`.
"""
file_extension(::File)

## Stream:

"""
    Stream{fmt}(io, filename=nothing)

Indicates that the stream `io` is written in known format [`DataFormat`](@ref)
`fmt`. For example, `Stream{format"PNG"}(io)` would indicate PNG format.
If known, the optional `filename` argument can
be used to improve error messages, etc.

!!! compat
    `Stream{fmt}(io, ...)` requires FileIO 1.6 or higher.
    The deprecated syntax `Stream(fmt, io, ...)` works on all FileIO 1.x releases.
"""
struct Stream{F <: DataFormat, IOtype <: IO, Name} <: Formatted{F}
    io::IOtype
    filename::Name
end

Stream{F,IOtype}(io::IO, filename::AbstractString) where {F<:DataFormat,IOtype} = Stream{F, IOtype, String}(io, String(filename))
Stream{F,IOtype}(io::IO, filename)                 where {F<:DataFormat,IOtype} = Stream{F, IOtype, typeof(filename)}(io, filename)
Stream{F,IOtype}(io::IO)                           where {F<:DataFormat,IOtype} = Stream{F, IOtype}(io, nothing)

Stream{F,IOtype}(file::Formatted{F}, io::IO) where {F<:DataFormat,IOtype} = Stream{F,IOtype}(io, filename(file))
Stream{F,IOtype}(@nospecialize(file::Formatted), io::IO) where {F<:DataFormat,IOtype} =
    throw(ArgumentError("cannot change the format of $file to $(formatname(F)::Symbol)"))

Stream{F}(io::IO, args...) where {F<:DataFormat} = Stream{F, typeof(io)}(io, args...)
Stream{F}(file::File, io::IO) where {F<:DataFormat} = Stream{F, typeof(io)}(file, io)
Stream(file::File{F}, io::IO) where {F<:DataFormat} = Stream{F}(io, filename(file))

stream(@nospecialize(s::Stream)) = s.io
"""
    stream(s)

Returns the stream associated with [`Stream`](@ref) `s`.
"""
stream(::Stream)

filename(@nospecialize(s::Stream)) = s.filename
"""
    filename(stream)

Returns a string of the filename associated with [`Stream`](@ref) `stream`,
or nothing if there is no file associated.
"""
filename(::Stream)

function file_extension(@nospecialize(f::Stream))
    fname = filename(f)
    (fname === nothing) && return nothing
    splitext(fname)[2]
end
"""
    file_extension(file)

Returns a nullable-string for the file extension associated with [`Stream`](@ref) `stream`.
"""
file_extension(::Stream)

# Note this closes the stream. It's useful when you've opened
# the file to check the magic bytes, but don't want to leave
# a dangling stream.
function file!(strm::Stream{F}) where F
    f = filename(strm)
    f === nothing && error("filename unknown")
    close(strm.io)
    File{F}(f)
end

# Implement standard I/O operations for File and Stream
@inline function Base.open(@nospecialize(file::File{F}), @nospecialize(args...)) where F<:DataFormat
    fn = filename(file)
    Stream{F}(open(fn, args...), abspath(fn))
end
Base.close(@nospecialize(s::Stream)) = close(stream(s))

Base.position(@nospecialize(s::Stream)) = position(stream(s))
Base.seek(@nospecialize(s::Stream), offset::Integer) = (seek(stream(s), offset); s)
Base.seekstart(@nospecialize(s::Stream)) = (seekstart(stream(s)); s)
Base.seekend(@nospecialize(s::Stream)) = (seekend(stream(s)); s)
Base.skip(@nospecialize(s::Stream), offset::Integer) = (skip(stream(s), offset); s)
Base.eof(s::Stream) = eof(stream(s))

@inline Base.read(s::Stream, args...)  = read(stream(s), args...)
Base.read!(s::Stream, array::Array) = read!(stream(s), array)
@inline Base.write(s::Stream, args...) = write(stream(s), args...)
# Note: we can't sensibly support the all keyword. If you need that,
# call read(stream(s), ...; all=value) manually
Base.readbytes!(s::Stream, b) = readbytes!(stream(s), b)
Base.readbytes!(s::Stream, b, nb) = readbytes!(stream(s), b, nb)
Base.read(s::Stream) = read(stream(s))
Base.read(s::Stream, nb) = read(stream(s), nb)
Base.flush(s::Stream) = flush(stream(s))

Base.isreadonly(s::Stream) = isreadonly(stream(s))
Base.isopen(s::Stream) = isopen(stream(s))

using FileIO
using Test

@testset "Mime save" begin

    function Base.show(io::IO, m::MIME"image/svg+xml", data::MimeSaveTestType)
        content = read(joinpath(@__DIR__, "files", "mimesavetest.svg"))
        write(io, content)
    end

    function Base.show(io::IO, m::MIME"application/pdf", data::MimeSaveTestType)
        content = read(joinpath(@__DIR__, "files", "mimesavetest.pdf"))
        write(io, content)
    end

    function Base.show(io::IO, m::MIME"application/eps", data::MimeSaveTestType)
        content = read(joinpath(@__DIR__, "files", "mimesavetest.eps"))
        write(io, content)
    end

    function Base.show(io::IO, m::MIME"image/png", data::MimeSaveTestType)
        content = read(joinpath(@__DIR__, "files", "mimesavetest.png"))
        write(io, content)
    end

    function Base.show(io::IO, m::MIME"text/html", data::MimeSaveTestType)
        content = read(joinpath(@__DIR__, "files", "mimesavetest.html"))
        write(io, content)
    end

    data = MimeSaveTestType()

    # Test with string and paths
    for output_filename in (tempname(), tmpname())
        for filetype in [".svg", ".pdf", ".eps", ".png", ".html"]

            try
                save(output_filename * filetype, data)

                content_original = read(joinpath(@__DIR__, "files", "mimesavetest$filetype"))
                content_new = read(output_filename * filetype)

                @test content_new == content_original
            finally
                isfile(output_filename * filetype) && rm(output_filename * filetype)
            end

            # Functional form
            data |> save(output_filename * filetype)
            try
                content_original = read(joinpath(@__DIR__, "files", "mimesavetest$filetype"))
                content_new = read(output_filename * filetype)

                @test content_new == content_original
            finally
                rm(output_filename * filetype)
            end

        end
    end

end

# World age issue

## Motivation: lazy loading

The goal of FileIO is to provide a unified IO frontend so that users can easily deal with file IO
with the simple `load`/`save` functions. The actual IO work will be dispatched to various IO
backends. For instance, [PNGFiles.jl](https://github.com/JuliaIO/PNGFiles.jl) is used to load PNG
format images. If `using FileIO` were to load all registered IO backends, then it would be very slow
to load, hurting all users of FileIO. For any given user, most of those backends would also be
unnecessary -- for example, people who don't do image processing probably don't want to load any
thing related to image IO.

To avoid such unnecessary loading latency, FileIO defers package loading until it's actually used.
For instance, when you use FileIO, you'll probably observe something like this:

```julia-repl
julia> using TestImages, FileIO

julia> path = testimage("cameraman"; download_only=true)
"/home/jc/.julia/artifacts/27a4c26bcdd47eb717bee089ec231a899cb8ef69/cameraman.tif"

julia> load(path) # actual backend loading happens here
[ Info: Precompiling ImageIO [82e4d734-157c-48bb-816b-45c225c6df19]
[ Info: Precompiling TiffImages [731e570b-9d59-4bfa-96dc-6df516fadf69]
...
```

ImageIO and TiffImages were loaded because the file in `path` was detected to be a TIFF image, well
after FileIO was loaded into the session.

## The hidden issue

Although this lazy-loading trick reduces the time needed for `using FileIO`, it isn't normal
practice in Julia because it introduces a so-called _world age issue_ or _world age problem_. The
world age issue happens when you call methods that get compiled in a newer "world" (get compiled
after initial compilation finishes) than the one you called them from.

Let's demonstrate the problem concretely. In case you don't have a suitable file to play with, let's
first create one:

```julia-repl
julia> using IndirectArrays, ImageCore

julia> img = IndirectArray(rand(1:5, 4, 4), rand(RGB, 5))
4×4 IndirectArray{RGB{Float64}, 2, Int64, Matrix{Int64}, Vector{RGB{Float64}}}:
[...]

julia> save("indexed_image.png", img)
```

Now, **reopen a new julia REPL** (this is crucial for demonstrating the problem) and call `load`
from **within a function** (this is also crucial):

```julia-repl
julia> using FileIO

julia> f() = size(load("indexed_image.png"))
f (generic function with 1 method)

julia> f()
ERROR: MethodError: no method matching size(::IndirectArrays.IndirectArray{ColorTypes.RGB{FixedPointNumbers.N0f8}, 2, UInt8, Matrix{UInt8}, OffsetArrays.OffsetVector{ColorTypes.RGB{FixedPointNumbers.N0f8}, Vector{ColorTypes.RGB{FixedPointNumbers.N0f8}}}})
The applicable method may be too new: running in world age 32382, while current world is 32416.
Closest candidates are:
  size(::IndirectArrays.IndirectArray) at ~/.julia/packages/IndirectArrays/BUQO3/src/IndirectArrays.jl:52 (method too new to be called from this world context.)
  size(::AbstractArray{T, N}, ::Any) where {T, N} at abstractarray.jl:42
  size(::Union{LinearAlgebra.Adjoint{T, var"#s880"}, LinearAlgebra.Transpose{T, var"#s880"}} where {T, var"#s880"<:(AbstractVector)}) at /Applications/Julia-1.8.app/Contents/Resources/julia/share/julia/stdlib/v1.8/LinearAlgebra/src/adjtrans.jl:173
  ...
Stacktrace:
 [1] f()
   @ Main ./REPL[2]:1
 [2] top-level scope
   @ REPL[3]:1
```

To understand why this happened, you have to understand the order of events:

1. When calling `f()` from the REPL, Julia first compiled `f`. Importantly, when compiling, Julia
   didn't know what type of object was going to be returned by `load`, so in the compiled code it
   waits to see what object actually gets returned before figuring out which method of `size` to
   call. (This is called _runtime dispatch_.)
2. It queried the file, recognized a PNG file, and _loaded the ImageIO and PNGFiles packages_. (It's
   for the loading of these packages that you needed to start a fresh Julia session.)
3. FileIO calls the appropriate PNG-specific `load` function in PNGFiles. (We'll have more to say
   about this step further below.) This causes an image to be returned, which is an array of a type
   defined by the IndirectArrays package (a dependency of PNGFiles).
4. `f` calls `size` on the returned image. However, this fails, because at the time you called `f`,
   the IndirectArrays package wasn't loaded.

In other words, `size` method for `IndirectArray` lives in a world that's newer than the one from
which you called `f()`. This leads to the observed error.

!!! note
    World age is crucial to Julia's ability to allow you to _redefine_ methods interactively, but
    the error we're illustrating is an unfortunate side-effect.

The good news is it's easy to fix, just try calling `f()` again:

```julia-repl
julia> f()
(4, 4)
```

The second `f()` works because this time you're calling `f()` in the latest world age with the
necessary `size(::IndirectArray)` already defined. In essence, you fast-forward to the latest world
with each statement you type at the REPL.

## Solutions

### `Base.invokelatest`

One solution is to make the call to `size` via `Base.invokelatest`, which exists explicitly to work
around this world-age dispatch problem. Literally, `invokelatest` dispatches the supplied call using
the latest world age (which may be newer than when you typed `f()` at the REPL). **In a fresh Julia
session**,

```julia-repl
julia> using FileIO

julia> f() = Base.invokelatest(size, load("indexed_image.png"))
f (generic function with 1 method)

julia> f()
(4, 4)
```

!!! note
    In step 3 above ("FileIO calls the appropriate PNG-specific `load` function in PNGFiles"),
    the call to the `load` function defined in PNGFiles is made via `invokelatest`.
    Otherwise, even ordinary interactive usage of FileIO (without burying `load` inside a function)
    would cause world-age errors.

!!! warning
    Using `invokelatest` slows your code considerably. Use it only when absolutely necessary.

### Eagerly load the required packages first

Another solution to the world age issue is simple and doesn't have long-term downsides: **eagerly
load the needed packages**. For instance, if you're seeing world age issue complaining methods
related to `IndirectArray`, then load IndirectArrays eagerly:

```julia-repl
julia> using FileIO, IndirectArrays # try this on a new Julia REPL

julia> f() = size(load("indexed_image.png"))
f (generic function with 1 method)

julia> f()
(4, 4)
```

Thus if you want to build a package, it could be something like this:

```julia
module MyFancyPackage

# This ensures that whoever loads `MyFancyPackage`, he has IndirectArrays loaded and
# thus avoid the world age issue.
using IndirectArrays, FileIO

f(file) = length(load(file))
end
```

Enjoy the FileIO and its lazy loading, but be aware that its speedy loading comes with some caveats.

# Implementing loaders/savers

## Principle of operation: module qualification

When FileIO detects that a file or stream should be handled by a particular package, it will try to call *private* methods in that package for processing the request.
For example, suppose you have created a package called `MyFileFormat` to handle files of a particular format; then `load("somefile.myfmt")` for a suitable file will cause FileIO to:

- attempt to load your package `MyFileFormat` using `Base.require(id::PkgId)`, where a `PkgId` combines the name and `UUID` that you supplied via `add_format`
- call `MyFileFormat.load(file)` where `file` is [`File`](@ref).

A crucial point is that **`MyFileFormat.load` does not extend `FileIO.load`: it is a private function defined in module `MyFileFormat`**. This is important for ensuring that single formats can be supported by multiple packages; if two or more packages specialized `File.load` for `file::File{format"MYFORMAT"})`, then

```julia
using Pkg1, Pkg2   # two packages both inappropriately extending FileIO.load
```

would cause all such loads to be handled by `Pkg2`, but

```julia
using Pkg2, Pkg1
```

would cause them to be handled by `Pkg1`.
This would make loading incredibly brittle.
For that reason, it is essential to keep `load` private to your package and let FileIO call it by module-qualification.

The same applies to `save`, `loadstreaming`, and `savestreaming`.

If you run into a naming conflict with the `load` and `save` functions
(for example, you already have another function in your package that has
one of these names), you can instead name your loaders `fileio_load`,
`fileio_save` etc. Note that you cannot mix and match these styles: either
all your loaders have to be named `load`, or all of them should be called
`fileio_load`, but you cannot use both conventions in one module.

## All-at-once I/O: implementing `load` and `save`

In your package, write code like the following:

```julia
module MyFileFormat

using FileIO

# Again, this is a *private* `load` function, do not extend `FileIO.load`!
function load(f::File{format"PNG"})
    open(f) do s
        skipmagic(s)  # skip over the magic bytes
        # You can just call the `load(::Stream)` method below...
        ret = load(s)
        # ...or implement everything here instead
    end
end

# You can support streams and add keywords:
function load(s::Stream{format"PNG"}; keywords...)
    # s is already positioned after the magic bytes
    # Do the stuff to read a PNG file
    chunklength = read(s, UInt32)
    ...
end

function save(f::File{format"PNG"}, data)
    open(f, "w") do s
        # Don't forget to write the magic bytes!
        write(s, magic(format"PNG"))
        # Do the rest of the stuff needed to save in PNG format
    end
end

end # module MyFileFormat
```

`load(::File)` and `save(::File)` should close any streams
they open.  (If you use the `do` syntax, this happens for you
automatically even if the code inside the `do` scope throws an error.)
Conversely, `load(::Stream)` and `save(::Stream)` should not close the
stream argument.

## Implementing streaming I/O

`loadstreaming` and `savestreaming` use the same query mechanism, but return a
decoded stream that users can `read` or `write`. You should also implement a
`close` method on your reader or writer type. Just like with `load` and `save`,
if the user provided a filename, your `close` method should be responsible for
closing any streams you opened in order to read or write the file. If you are
given a `Stream`, your `close` method should only do the clean up for your
reader or writer type, not close the stream.

```julia
struct WAVReader
    io::IO
    ownstream::Bool
end

function Base.read(reader::WAVReader, frames::Int)
    # read and decode audio samples from reader.io
end

function Base.close(reader::WAVReader)
    # do whatever cleanup the reader needs
    reader.ownstream && close(reader.io)
end

# FileIO has fallback functions that make these work using `do` syntax as well,
# and will automatically call `close` on the returned object.
loadstreaming(f::File{format"WAV"}) = WAVReader(open(f), true)
loadstreaming(s::Stream{format"WAV"}) = WAVReader(s, false)
```

If you choose to implement `loadstreaming` and `savestreaming` in your package,
you can easily add `save` and `load` methods in the form of:

```julia
function save(q::Formatted{format"WAV"}, data, args...; kwargs...)
    savestreaming(q, args...; kwargs...) do stream
        write(stream, data)
    end
end

function load(q::Formatted{format"WAV"}, args...; kwargs...)
    loadstreaming(q, args...; kwargs...) do stream
        read(stream)
    end
end
```

where `Formatted` is the abstract supertype of `File` and `Stream`.

| Format Name | extensions | IO library | detection or magic number |
| ----------- | ---------- | ---------- | ---------- |
| JLD | .jld | loads and saves on **all** platforms with [JLD](http:///github.com/JuliaLang/JLD.jl.git)  | Julia data file (HDF5) |
| PBMBinary | .pbm | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x50,0x34] |
| PGMBinary | .pgm | loads and saves on **all** platforms with [Netpbm](http:///github.com/JuliaIO/Netpbm.jl.git)  | UInt8[0x50,0x35] |
| PPMBinary | .ppm | loads and saves on **all** platforms with [Netpbm](http:///github.com/JuliaIO/Netpbm.jl.git)  | UInt8[0x50,0x36] |
| PBMText | .pbm | loads with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git) on: **all** platforms   | UInt8[0x50,0x31] |
| PGMText | .pgm | loads with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git) on: **all** platforms   | UInt8[0x50,0x32] |
| PPMText | .ppm | loads with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git) on: **all** platforms   | UInt8[0x50,0x33] |
| NRRD | .nrrd, .nhdr | loads and saves on **all** platforms with [NRRD](http:///github.com/JuliaIO/NRRD.jl.git)  | NRRD |
| AndorSIF | .sif | loads with [AndorSIF](http:///github.com/JuliaIO/AndorSIF.jl.git) on: **all** platforms   | Andor Technology Multi-Channel File |
| CRW | .crw | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x49,0x49,0x1a,0x00,0x00,0x00,0x48,0x45] |
| CUR | .cur | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x00,0x00,0x02,0x00] |
| DCX | .dcx | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0xb1,0x68,0xde,0x3a] |
| DOT | .dot | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0xd0,0xcf,0x11,0xe0,0xa1,0xb1,0x1a,0xe1] |
| EPS | .eps | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x25,0x21,0x50,0x53,0x2d,0x41,0x64,0x6f] |
| HDR | .hdr | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x23,0x3f,0x52,0x41,0x44,0x49,0x41,0x4e] |
| ICO | .ico | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x00,0x00,0x01,0x00] |
| INFO | .info | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x7a,0x62,0x65,0x78] |
| JP2 | .jp2 | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x00,0x00,0x00,0x0c,0x6a,0x50,0x20,0x20] |
| PCX | .pcx | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x0a,0x05,0x01,0x01] |
| PDB | .pdb | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x73,0x7a,0x65,0x7a] |
| PDF | .pdf | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x25,0x50,0x44,0x46] |
| PGM | .pgm | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x50,0x35,0x0a] |
| PSD | .psd | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x38,0x42,0x50,0x53] |
| RGB | .rgb | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x01,0xda,0x01,0x01,0x00,0x03] |
| WMF | .wmf | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0xd7,0xcd,0xc6,0x9a] |
| WPG | .wpg | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0xff,0x57,0x50,0x43] |
| Imagine | .imagine | loads and saves on **all** platforms with [ImagineFormat](http:///github.com/timholy/ImagineFormat.jl.git)  | IMAGINE |
| TGA | .tga | loads and saves on **all** platforms with [QuartzImageIO](http:///github.com/JuliaIO/QuartzImageIO.jl.git) loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | only extension |
| GIF | .gif | loads and saves on **all** platforms with [QuartzImageIO](http:///github.com/JuliaIO/QuartzImageIO.jl.git) loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x47,0x49,0x46,0x38] |
| PNG | .png | loads and saves on **all** platforms with [QuartzImageIO](http:///github.com/JuliaIO/QuartzImageIO.jl.git) loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a] |
| TIFF | .tiff, .tif | loads and saves on **all** platforms with [QuartzImageIO](http:///github.com/JuliaIO/QuartzImageIO.jl.git) loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | (UInt8[0x4d,0x4d,0x00,0x2a],UInt8[0x4d,0x4d,0x00,0x2b],UInt8[0x49,0x49,0x2a,0x00]) |
| JPEG | .jpeg, .jpg, .JPG | loads and saves on **all** platforms with [QuartzImageIO](http:///github.com/JuliaIO/QuartzImageIO.jl.git) loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0xff,0xd8,0xff] |
| BMP | .bmp | loads and saves on **all** platforms with [QuartzImageIO](http:///github.com/JuliaIO/QuartzImageIO.jl.git) loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | UInt8[0x42,0x4d] |
| GLSLShader | .frag, .vert, .geom, .comp | loads and saves on **all** platforms with [GLAbstraction](http:///github.com/JuliaGL/GLAbstraction.jl.git)  | only extension |
| OBJ | .obj | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | only extension |
| PLY_ASCII | .ply | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | ply
format ascii 1.0 |
| PLY_BINARY | .ply | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | ply
format binary_little_endian 1.0 |
| 2DM | .2dm | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | MESH2D |
| OFF | .off | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | OFF |
| AVI | .avi | loads and saves on **all** platforms with [ImageMagick](http:///github.com/JuliaIO/ImageMagick.jl.git)  | has detection function |
| HDF5 | .h5, .hdf5 | loads and saves on **all** platforms with [HDF5](http:///github.com/JuliaLang/HDF5.jl.git)  | has detection function |
| STL_ASCII | .stl, .STL | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | has detection function |
| STL_BINARY | .stl, .STL | loads and saves on **all** platforms with [MeshIO](http:///github.com/JuliaIO/MeshIO.jl.git)  | has detection function |
| NPY | .npy | loads and saves on **all** platforms with [NPZ](https://github.com/fhs/NPZ.jl)  | "\x93NUMPY" |
| NPZ | .npz | loads and saves on **all** platforms with [NPZ](https://github.com/fhs/NPZ.jl)  | "PK\x03\x04" |

# FileIO.jl

FileIO aims to provide a common framework for detecting file formats
and dispatching to appropriate readers/writers.  The two core
functions in this package are called `load` and `save`, and offer
high-level support for formatted files (in contrast with julia's
low-level `read` and `write`).  To avoid name conflicts, packages that
provide support for standard file formats through functions named
`load` and `save` are encouraged to register with FileIO.

## Installation

Install FileIO within Julia via

```julia
using Pkg
Pkg.add("FileIO")
```

## Usage

If your format has been registered, it might be as simple as

```julia
using FileIO
obj = load(filename)
```

to read data from a formatted file. FileIO will attempt to find
an installed package capable of reading `filename`; if no such
package is found, it will suggest an appropriate package for you
to add. It doesn't even have to be a file; you can download the Julia logo
with

```jldoctest
julia> using FileIO, HTTP

julia> img = load(HTTP.URI("https://github.com/JuliaLang/julia-logo-graphics/raw/master/images/julia-logo-color.png"));

julia> typeof(img)
Matrix{RGBA{N0f8}} (alias for Array{ColorTypes.RGBA{FixedPointNumbers.Normed{UInt8, 8}}, 2})
```

Likewise, saving might be as simple as

```julia
save(filename, obj)
```

You can also utilize a piping style to save values to files like this

```julia
obj |> save(filename)
```

If you just want to inspect a file to determine its format, then

```julia
file = query(filename)
s = query(io)   # io is a stream
```

will return a `File` or `Stream` object that also encodes the detected
file format.

Sometimes you want to read or write files that are larger than your available
memory, or might be an unknown or infinite length (e.g. reading an audio or
video stream from a socket). In these cases it might not make sense to process
the whole file at once, but instead process it a chunk at a time. For these
situations FileIO provides the `loadstreaming` and `savestreaming` functions,
which return an object that you can `read` or `write`, rather than the file data
itself.

This would look something like:

```julia
using FileIO
audio = loadstreaming("bigfile.wav")
try
    while !eof(audio)
        chunk = read(audio, 4096) # read 4096 frames
        # process the chunk
    end
finally
    close(audio)
end
```

or use `do` syntax to auto-close the stream:

```julia
using FileIO
loadstreaming("bigfile.wav") do audio
    while !eof(audio)
        chunk = read(audio, 4096) # read 4096 frames
        # process the chunk
    end
end
```

Note that in these cases you may want to use `read!` with a pre-allocated buffer
for maximum efficiency.

## Supported formats

The existing supported formats are summarized in the [Registry table](@ref).

## Supporting new formats

If you want to extend FileIO's support for new formats, there are two separate steps:

- [Registering a new format](@ref) with FileIO
- [Implementing loaders/savers](@ref) in your package

These steps can be done in either order.

# Registering a new format

You register a new format by adding

```julia
add_format(fmt, magic, extension, libraries...)
```

to FileIO's [registry](https://github.com/JuliaIO/FileIO.jl/blob/master/src/registry.jl).
It's generally best if you experiment with this locally and make sure everything works
before submitting a pull request.
You'll need to [`pkg> dev FileIO`](https://julialang.github.io/Pkg.jl/v1/managing-packages/#developing) to make the required changes.

Before going into detail explaining the arguments of `add_format`,
here is a real example that could be used to register an I/O package for one of the [Netpbm image formats](https://en.wikipedia.org/wiki/Netpbm#File_formats):

```julia
add_format(format"PPMBinary", "P6", ".ppm", [:Netpbm => UUID("f09324ee-3d7c-5217-9330-fc30815ba969")])
```

Briefly, this indicates that files in this format typically have extension `.ppm`, the file contents typically start with "P6" (the byte sequence `[0x50, 0x36]`), and these files can be read and written by the [Netpbm package](https://github.com/JuliaIO/Netpbm.jl). (The `UUID` is Julia's unique identifier for this registered package and can be obtained from the `Project.toml` file.)

## Argument `fmt`

`fmt` is a `DataFormat` type, most conveniently created as `format"IDENTIFIER"`.
If this file format has not previously been supported,
you can make up `IDENTIFIER` yourself--there is no external standard, this is just a "tag"
used internally by FileIO and its support routines.
You should generally choose something that makes it easy to guess what format it refers to.
Examples of some existing `fmt`s are:

- `format"PNG"`: the format for [png image files](https://en.wikipedia.org/wiki/Portable_Network_Graphics)
- `format"HDF5"`: the format for [hierarchical data files v5](https://en.wikipedia.org/wiki/Hierarchical_Data_Format)

## Argument `magic`

`magic` typically contains the [magic bytes](https://en.wikipedia.org/wiki/File_format#Magic_number) that identify the format.
While file format can sometimes be guessed from the extension (e.g., "pic.png" would likely be a PNG image file),
fundamentally the name of the file is something that can be changed by the user,
so it may have no relationship to the content of the file.
Moreover, there are many examples in which two or more different formats use the same extension,
leading to ambiguity about the nature of the file.
Is a `.gbv` file a Genie Timeline file or a PCB CAD file?
Is that `.fst` file an audio file, a puzzle game file, or an R serialized dataframe file?

To identify the file uniquely, good format designers will include "magic bytes" as part of the content of the file to ensure that one can recognize or validate the format of the file.
Typically, these magic bytes are the first bytes in the file, although there are many exceptions.

!!! warning
    Formats that use common extensions (e.g., `.out`) and lack magic bytes cannot be registered with FileIO--
    permitting this would force us to choose one particular format above all others.
    In such cases, your package should provide its own I/O without using FileIO.
    To avoid name conflicts with FileIO, it may be best to avoid exporting names like `load` and `save` from your package; use module-qualifiers like `MyPkg.load` instead.

Some formats have multiple "flavors" of magic bytes (which might, for example, include a "format version" number);
in such cases `magic` can be a list of byte sequences.
In other cases, files cannot be identified by a specific set of bytes, but there's a pattern that can be exploited:
`magic` can be a function that returns `true` or `false` depending on whether an I/O stream
is consistent with the format.

Examples of magic bytes include:
- [GIF image files](https://en.wikipedia.org/wiki/GIF) can have magic bytes corresponding to the ASCII characters in `"GIF87a"`, i.e., `[0x47, 0x49, 0x46, 0x38, 0x37, 0x61]`. Alternatively, they might use `"GIF89a"`, which signals a different version of the GIF format.
- [PLY mesh files](https://en.wikipedia.org/wiki/PLY_(file_format)) can come in two flavors, ASCII and binary. Their magic bytes are `"ply\nformat ascii 1.0"` and `"ply\nformat binary_little_endian 1.0"`, respectively. These magic bytes are human-readable and span the first two lines of the file.
- [BedGraph genomic data files](http://genome.ucsc.edu/goldenPath/help/bedgraph.html) do not have official magic bytes, but they do have a structure which can be fairly reliably recognized by a suitable detection function. (Though it would have made life far more straightforward if the creators of the format had just added some magic bytes!)

## Argument `extension`

This can be a string or list of strings. Each should start with `'.'`.

Example: the [Nearly Raw Raster Data](http://teem.sourceforge.net/nrrd/format.html) format uses `[".nrrd",".nhdr"]`.

## Argument `libraries`

This argument specifies the package or packages that can support input and/or output for the format.
Each package specification should be of the form `name => uuid`, where `name` is the name of the package (encoded as a `Symbol`, e.g., `:FeatherFiles`) and `uuid` is the `UUID` from the package's `Project.toml`.
The first-to-be listed package has highest priority; FileIO will try to use it to perform the requested operation, and move onto the next only if that fails.
Failure might occur because the user does not have the package installed, or because the package's handler threw an error.

Some packages may only support specific forms of I/O, and can use `LOAD` and `SAVE` as specifiers for supported operations. Likewise, some packages rely on system libraries available only on certain platforms, and can include a platform specifier.

If your package isn't (yet) registered, you can alternatively specify the handler as the module itself.  In such cases, your call to `add_format` will likely be made from within your module or at the Julia REPL rather than in FileIO's registry. An exception is `MimeWriter`, a sub-module of `FileIO` that can write a few [MIME](https://en.wikipedia.org/wiki/MIME) formats.

Here's a real-world example (contained in FileIO's `src/registry.jl`) for PNG:

```julia
add_format(
    format"PNG",
    UInt8[0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a],
    ".png",
    [idImageIO],
    [idQuartzImageIO, OSX],
    [idImageMagick],
    [MimeWriter, SAVE]
)
```

`idImageIO`, `idQuartzImageIO`, and `idImageMagic` are `name => uuid` pairs for three different packages.
[QuartzImageIO](https://github.com/JuliaIO/QuartzImageIO.jl) is available only on macOS (`OSX`).
The `MimeWriter` module (which is internally accessible to FileIO) only supports output (`SAVE`), not input.

## Examples

For further examples, users are encouraged to inspect FileIO's [registry](https://github.com/JuliaIO/FileIO.jl/blob/master/src/registry.jl) directly.
